<?php
fprintf(STDERR,"Offline tool allowing to compute the vertices of the flux cone\n");
fprintf(STDERR,"Notice that it is an approximate computation. If you do not test\n");
fprintf(STDERR,"enough random objective, you may miss some vertices.\n");
fprintf(STDERR,"The total number of tested objectives is nb_processes * nb_objectives_per_process.\n");
fprintf(STDERR,"You will be asked to define both values\n");
fprintf(STDERR,"--------------------------------------------------------------\n");
fprintf(STDERR,"1) Launch the computation\n");
fprintf(STDERR,"2) Verify if the computation is finished\n");
fprintf(STDERR,"3) Group the computed vertices\n");
fprintf(STDERR,"NB: you must do 1), wait until all the vertices are computed and then 3)\n");
fprintf(STDERR,"Your choice ?");
$choice=trim(fgets(STDIN,4096));

switch ($choice) {
case "1":
fprintf(STDERR,"You must provide a .mdl file. Filename=");
$filename=trim(fgets(STDIN,4096));
fprintf(STDERR,"Are you on a SGI based cluster ? [y/N] ");
$answer=trim(fgets(STDIN,4096));
$answer=($answer == "y" || $answer == "Y")?"Y":"N";


if ($answer == "Y") {
	system("rm solutions_calculees*.txt pbtosolve.tmp\n");
	fprintf(STDERR,"Maximum number of nodes used [100 is good] = ");
	$maxtirages=trim(fgets(STDIN,4096));
	fprintf(STDERR,"Number of objectives per nodes [10 is good] = ");
	$nbtirages=trim(fgets(STDIN,4096));

	for($i=1; $i<=$maxtirages; $i++) {
		$fd=fopen("script".$i.".sh","w");
		fputs($fd,"cd ".exec("pwd")."\n");
		fputs($fd,"php unsommet.php ".$filename." ".$i." ".$nbtirages."\n");
		fclose($fd);
		system(sprintf("qsub script%d.sh\n",$i));
		system(sprintf("rm script%d.sh\n",$i));
	}
} else {
	system("rm solutions_calculees*.txt pbtosolve.tmp script*.sh\n");
	fprintf(STDERR,"Maximum number of processes used (coarse grain parallization for a multicore computer) [20 is good] = ");
	$maxtirages=trim(fgets(STDIN,4096));
	fprintf(STDERR,"Number of objectives per processes [10 is good] = ");
	$nbtirages=trim(fgets(STDIN,4096));

	for($i=1; $i<=$maxtirages; $i++) {
		$fd=fopen("script".$i.".sh","w");
//		fputs($fd,"cd Sommets\n");
		fputs($fd,"php unsommet.php ".$filename." ".$i." ".$nbtirages."\n");
		fclose($fd);
		system(sprintf("sh script%d.sh >/dev/null 2>/dev/null&\n",$i));
	}
}
break;

case "2":
	fprintf(STDERR,"Are you on a SGI based cluster ? [y/N] ");
	$answer=trim(fgets(STDIN,4096));
	$answer=($answer == "y" || $answer == "Y")?"Y":"N";
	if ($answer == "N") {
	fprintf(STDERR,"Remaining active processes : \n");
	fprintf(STDERR,"----------------------\n");
	passthru("ps aux | grep \"sh script\"| grep -v \"grep\"");
	fprintf(STDERR,"----------------------\n");
	} else {
	fprintf(STDERR,"Remaining active nodes : \n");
	fprintf(STDERR,"----------------------\n");
	passthru("qstat | grep script");
	fprintf(STDERR,"----------------------\n");
	}
break;

case "3":
fprintf(STDERR,"You must provide an output filename [eg. sortie.csv]. Filename=");
$outputfile=trim(fgets(STDIN,4096));
system("php unsommet.php rien 0 0 > ".$outputfile);
break;
default:
	fprintf(STDERR,"Bad choice !");
}
?>
