<?php

// CONSTANTES
$Tous_types_colonnes=array("Unused","Reaction","Reaction Number","Intermediary metabolite","Balanced cofactor","Measured as Input or Output","Maximization objective","Minimization objective", "Predicted Input or Output", "Calculated (uniquely for distribution)");

function efface(&$T) {
	foreach($T as $cle=>$valeur) unset($T[$cle]);
}

include("SolverGauss.php");

class Modele {
	// La matrice stoechiométrique complète
	var $matrice_stoechiometrique=array();

	// Equations utilisées
	var $equations_utilisees=array();

	// Noms des colonnes
	var $noms_colonnes=array();

	// Types des colonnes (un entier correspondant à la constante Tous_types_colonnes)
	var $types_colonnes=array();

	// contraintes supplémentaires
	var $contraintes=array();

	// entrées/sorties Nom
	var $Entrees_Sorties=array();

	// Solution
	var $Solution=array();
	
	// Sorties
	var $Sorties=array();
	
	// Entrees
	var $Entrees=array();
	
	
	// retourne le nombre de réactions
	function NbEquations() {return count($this->matrice_stoechiometrique); }
	
	function read($filename) {
		efface($this->matrice_stoechiometrique);
		efface($this->equations_utilisees);
		efface($this->noms_colonnes);
		efface($this->types_colonnes);
		efface($this->contraintes);
		efface($this->Entrees_Sorties);
		efface($this->Solution);
		efface($this->Sorties);
		efface($this->Entrees);
	
		
		
	    $fd=fopen($filename, "r");
		$type_lecture_courante="";
		$chaines_lecture=array(""=>0, "Matrice"=>1, "EquationsUtilisees"=>2, "NomsColonnes"=>3, "TypesColonnes"=>4, "contraintes"=>5, "EntreesSorties"=>6, "Solution"=>7, "Sorties"=>8, "Entrees"=>9);
		while (! feof($fd)) {
			switch ($chaines_lecture[$type_lecture_courante]) {
				case 1: // lecture matrice stoechiometrique
					$i=0;
					do {
						$ligne=trim(fgets($fd,65536));
						if (strcmp($ligne,"END") != 0) {
							if ($ligne != "") $this->matrice_stoechiometrique[$i++]=explode(";",$ligne);
						}
					} while ((! feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				case 2: // lecture Equations utilisées
					$i=0;
					do {
						$ligne=trim(fgets($fd,4096));
						if (strcmp($ligne,"END") != 0) {
							$this->equations_utilisees[$i++]=$ligne;
						}
					} while ((! feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				case 3: // lecture nom colonnes
					$i=0;
					do {
						$ligne=trim(fgets($fd,4096));
						if (strcmp($ligne,"END") != 0) {
							$this->noms_colonnes[$i++]=$ligne;
						}
					} while ((!feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				case 4: // lecture types colonnes
					$i=0;
					do {
						$ligne=trim(fgets($fd,4096));
						if (strcmp($ligne,"END") != 0) {
							$this->types_colonnes[$i++]=$ligne;
						}
					} while ((!feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				case 5: // lecture contraintes
					$i=0;
					do {
						$ligne=trim(fgets($fd,4096));
						if (strcmp($ligne,"END") != 0) {
							$this->contraintes[$i++]=$ligne;
						}
					}
					while ((!feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				case 6: // lecture Entrées Sorties
					$i=0;
					do {
						$ligne=trim(fgets($fd,4096));
						if (strcmp($ligne,"END") != 0) {
							$this->Entrees_Sorties[$i++]=$ligne;
						}
					} while ((!feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				case 7: // lecture Solution
					$i=0;
					do {
						$ligne=trim(fgets($fd,4096));
						if (strcmp($ligne,"END") != 0) {
							$this->Solution[$i++]=$ligne;
						}
					} while ((!feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				case 8: // lecture Sorties
					$i=0;
					do {
						$ligne=trim(fgets($fd,4096));
						if (strcmp($ligne,"END") != 0) {
							$this->Sorties[$i++]=$ligne;
						}
					} while ((!feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				case 9: // lecture Entrees
					$i=0;
					do {
						$ligne=trim(fgets($fd,4096));
						if (strcmp($ligne,"END") != 0) {
							$this->Entrees[$i++]=$ligne;
						}
					} while ((!feof($fd)) && (strcmp($ligne,"END") != 0));
					$type_lecture_courante="";
				break;
				
			
				default: // reste
					$ligne=trim(fgets($fd,4096));
					$type=substr($ligne,6);
					if (strcmp(substr($ligne,0,5),"BEGIN") == 0)
						if (isset($chaines_lecture[$type])) 
							$type_lecture_courante=$type;
			}
		}

		fclose($fd);		
	}
	
	
	// lecture de la stoechiométrie
	function read_stoechiometrique($filename) {
		efface($this->matrice_stoechiometrique);
		efface($this->equations_utilisees);
		efface($this->noms_colonnes);
		efface($this->types_colonnes);
		efface($this->contraintes);
		efface($this->Entrees_Sorties);
		efface($this->Solution);
		efface($this->Sorties);
		efface($this->Entrees);
	    $fd=fopen($filename, "r");
	    $this->noms_colonnes = fgetcsv($fd, 65536, ";");
		$i = 0;
		while ($this->matrice_stoechiometrique[$i++] = fgetcsv($fd,65536,";")) {}
		fclose($fd);
		for ($j=0; $j<count($this->matrice_stoechiometrique); $j++) {
			$this->Solution[$j]=0;
		}
		for ($j=0; $j<count($this->matrice_stoechiometrique); $j++) {
			$this->equations_utilisees[$j]=0;
			$this->Sorties[$j]=0;
			$this->Entrees[$j]=0;
			$this->contraintes[$j]=0;
		}
		for ($j=0; $j<count($this->noms_colonnes); $j++) {
			$this->types_colonnes[$j]=0;
		}
		for ($j=0; $j<count($this->noms_colonnes); $j++) {
			$this->Entrees_Sorties[$j]=0;
		}	
	}


	// ecriture complete du fichier
	function write($filename) {
	    $fd=fopen($filename, "w");
		// Ecriture de la matrice stoechiometrique
		fprintf($fd,"BEGIN Matrice\n");
		for($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$flag=false;
			for($j=0; $j<count($this->matrice_stoechiometrique[$i]); $j++) {
				if ($flag) fprintf($fd,";");
				$flag=true;
				fprintf($fd,"%s",$this->matrice_stoechiometrique[$i][$j]);
			}
			fprintf($fd,"\n");
		}
		fprintf($fd,"END\n");
		
		// Ecriture des Equations utilisées
		fprintf($fd,"BEGIN EquationsUtilisees\n");
		for($i=0; $i<count($this->equations_utilisees); $i++) {
			fprintf($fd,"%s\n",$this->equations_utilisees[$i]);
		}
		fprintf($fd,"END\n");
		
		// Ecriture des Noms de colonnes
		fprintf($fd,"BEGIN NomsColonnes\n");
		for($i=0; $i<count($this->noms_colonnes); $i++) {
			fprintf($fd,"%s\n",$this->noms_colonnes[$i]);
		}
		fprintf($fd,"END\n");

		// Ecriture des Types de colonnes
		fprintf($fd,"BEGIN TypesColonnes\n");
		for($i=0; $i<count($this->types_colonnes); $i++) {
			fprintf($fd,"%s\n",$this->types_colonnes[$i]);
		}
		fprintf($fd,"END\n");

		// Ecriture des contraintes
		fprintf($fd,"BEGIN contraintes\n");
		for($i=0; $i<count($this->contraintes); $i++) {
			fprintf($fd,"%s\n",$this->contraintes[$i]);
		}
		fprintf($fd,"END\n");

		// Ecriture des Entrees Sorties
		fprintf($fd,"BEGIN EntreesSorties\n");
		for($i=0; $i<count($this->Entrees_Sorties); $i++) {
			fprintf($fd,"%s\n",$this->Entrees_Sorties[$i]);
		}
		fprintf($fd,"END\n");

		// Ecriture de la solution
		fprintf($fd,"BEGIN Solution\n");
		for($i=0; $i<count($this->equations_utilisees); $i++) {
			fprintf($fd,"%s\n",(isset($this->Solution[$i]))?$this->Solution[$i]:"");
		}
		fprintf($fd,"END\n");
		// Ecriture des sorties
		fprintf($fd,"BEGIN Sorties\n");
		for($i=0; $i<count($this->equations_utilisees); $i++) {
			fprintf($fd,"%s\n",(isset($this->Sorties[$i]))?$this->Sorties[$i]:"");
		}
		fprintf($fd,"END\n");
		// Ecriture des entrees
		fprintf($fd,"BEGIN Entrees \n");
		for($i=0; $i<count($this->equations_utilisees); $i++) {
			fprintf($fd,"%s\n",(isset($this->Entrees[$i]))?$this->Entrees[$i]:"");
		}
		fprintf($fd,"END\n");	
		fclose($fd);
	}

	function write_with_order($filename,$orderreactions, $ordermetabolites) {
	       	$fd=fopen($filename, "w");
		// Ecriture de la matrice stoechiometrique
		fprintf($fd,"BEGIN Matrice\n");
		for($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$flag=false;
			for($j=0; $j<count($this->matrice_stoechiometrique[$i]); $j++) {
				if ($flag) fprintf($fd,";");
				$flag=true;
				$indicei=(isset($orderreactions[$i])?$orderreactions[$i]:$i);
				$indicej=(isset($ordermetabolites[$j])?$ordermetabolites[$j]:$j);
				fprintf($fd,"%s",$this->matrice_stoechiometrique[$indicei][$indicej]);
			}
			fprintf($fd,"\n");
		}
		fprintf($fd,"END\n");
		
		// Ecriture des Equations utilisées
		fprintf($fd,"BEGIN EquationsUtilisees\n");
		fprintf($fd,"0\n"); // un bug ici. Petite rustine
		for($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$indicei=(isset($orderreactions[$i])?1+$orderreactions[$i]:1+$i);
			fprintf($fd,"%s\n",$this->equations_utilisees[$indicei]);
		}
		fprintf($fd,"END\n");
		
		// Ecriture des Noms de colonnes
		fprintf($fd,"BEGIN NomsColonnes\n");
		for($j=0; $j<count($this->noms_colonnes); $j++) {
				$indicej=(isset($ordermetabolites[$j])?$ordermetabolites[$j]:$j);
			fprintf($fd,"%s\n",$this->noms_colonnes[$indicej]);
		}
		fprintf($fd,"END\n");

		// Ecriture des Types de colonnes
		fprintf($fd,"BEGIN TypesColonnes\n");
		for($j=0; $j<count($this->types_colonnes); $j++) {
				$indicej=(isset($ordermetabolites[$j])?$ordermetabolites[$j]:$j);
			fprintf($fd,"%s\n",$this->types_colonnes[$indicej]);
		}
		fprintf($fd,"END\n");

		// Ecriture des contraintes
		fprintf($fd,"BEGIN contraintes\n");
		for($i=0; $i<count($this->contraintes); $i++) {
			fprintf($fd,"%s\n",$this->contraintes[$i]);
		}
		fprintf($fd,"END\n");

		// Ecriture des Entrees Sorties
		fprintf($fd,"BEGIN EntreesSorties\n");
		for($j=0; $j<count($this->Entrees_Sorties); $j++) {
			$indicej=(isset($ordermetabolites[$j])?$ordermetabolites[$j]:$j);
			fprintf($fd,"%s\n",$this->Entrees_Sorties[$indicej]);
		}
		fprintf($fd,"END\n");

		// Ecriture de la solution
		fprintf($fd,"BEGIN Solution\n");
		fprintf($fd,"0\n"); // un bug ici. Petite rustine
		for($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$indicei=(isset($orderreactions[$i])?1+$orderreactions[$i]:1+$i);
//			$indicei=(isset($orderreactions[$i])?$orderreactions[$i]:$i);
			fprintf($fd,"%s\n",$this->Solution[$indicei]);
		}
		fprintf($fd,"END\n");
		// Ecriture des sorties
		fprintf($fd,"BEGIN Sorties\n");
		fprintf($fd,"0\n"); // un bug ici. Petite rustine
		for($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$indicei=(isset($orderreactions[$i])?1+$orderreactions[$i]:1+$i);
			fprintf($fd,"%s\n",$this->Sorties[$indicei]);
		}
		fprintf($fd,"END\n");
		// Ecriture des entrees
		fprintf($fd,"BEGIN Entrees \n");
		fprintf($fd,"0\n"); // un bug ici. Petite rustine
		for($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$indicei=(isset($orderreactions[$i])?1+$orderreactions[$i]:1+$i);
			fprintf($fd,"%s\n",$this->Entrees[$indicei]);
		}
		fprintf($fd,"END\n");
		
		
		fclose($fd);
	}

// $Tous_types_colonnes=array("Unused","Reaction","Reaction Number","Intermediary metabolite","Balanced cofactor","Balanced Input/Output","Maximization objective","Minimization objective", "Balance computation", "Calculated (uniquely for distribution)");

	function getPartition(& $inr, &$metaboliteWeights, $printraw, $printformulas, $printbycols, $printbyrows) {
		$Entrees=array();
		$Sorties=array();
		$Reactions=array();
		$REntrees=array();
		$RSorties=array();
		$RIntern=array();
		$metabolitesP=array();
		$metabolitesC=array();
		$metabolites=array();
		$rid=array();
		$D=new Matrice();
		$R=array();
		for($i=0; $i<count($this->types_colonnes); $i++) {
			switch ($this->types_colonnes[$i]) {
				case 3: $metabolitesP[]=$i; $metabolites[$i]="I"; $R[$i]=array(); break;
				case 5: 
					$metabolitesP[]=$i; $metabolites[$i]="M"; $R[$i]=array(); break;
				case 4: $metabolitesP[]=$i;  break;
//				case 8: $metabolitesC[]=$i; break;
				case 8: $metabolitesP[]=$i; $metabolites[$i]="I"; $R[$i]=array(); break;
			}
		}
		
		$R=array();
		for($i=0; $i<count($this->equations_utilisees)-1; $i++) { // rustine
			if ($this->equations_utilisees[$i+1] == "on") {
				$rid[]=$i;
				$flagE=false;
				$flagS=false;
				for($j=0; $j<count($metabolitesP);$j++) {
					if ($this->matrice_stoechiometrique[$i][$metabolitesP[$j]]<0) 
						{$flagS=true;}
					if ($this->matrice_stoechiometrique[$i][$metabolitesP[$j]]>0) 
						{$flagE=true; $R[$metabolitesP[$j]][]=$i; } //$this->matrice_stoechiometrique[$i][0]; }
				}
//				echo "RR ".$i."=".$flagE.",".$flagS."\n";
				if ($flagE && !$flagS) {$REntrees[]=$i;}
				else if ($flagS && !$flagE) {$RSorties[]=$i;} else {$RIntern[]=$i;}
				
			}
		}
		
//		print_r($RSorties);
		
		for ($i=0; $i<count($REntrees); $i++) {
			for($j=0; $j<count($this->matrice_stoechiometrique[$REntrees[$i]]); $j++) { 
				if (isset($metabolites[$j]) && ($this->matrice_stoechiometrique[$REntrees[$i]][$j]*1 > 0)) {
					$Entrees[$j]=1; $metabolites[$j].=" E_".$this->matrice_stoechiometrique[$REntrees[$i]][0];
				}
			}
		}
		
//		echo "<pre>";
		
		for ($i=0; $i<count($RSorties); $i++) {
			for($j=0; $j<count($this->matrice_stoechiometrique[$RSorties[$i]]); $j++) { 
				if (isset($metabolites[$j]) && ($this->matrice_stoechiometrique[$RSorties[$i]][$j]*1 < 0)) {
					$Sorties[$j]=1; $metabolites[$j].=" S_".$this->matrice_stoechiometrique[$RSorties[$i]][0];
					
//					echo $this->noms_colonnes[$j]." sortie a cause de ".$this->matrice_stoechiometrique[$RSorties[$i]][0]."\n";
				}
			}
		}

//		echo "</pre>";

		
		// suppression des fausse entrées sorties ici
		foreach($Sorties as $cle=>$valeur) if (isset($Entrees[$cle]) && ($Entrees[$cle] == $valeur)) {$Entrees[$cle]=0; $Sorties[$cle]=0; 
		}
		
		$F=array();
		for($j=0; $j<count($metabolitesP);$j++) {
			$F[$metabolitesP[$j]]=0;
			for($i=0; $i<count($this->equations_utilisees)-1; $i++) { // rustine
				if ($this->equations_utilisees[$i+1] == "on") {
					$F[$metabolitesP[$j]]+=$this->Solution[$i+1] * max(0,$this->matrice_stoechiometrique[$i][$metabolitesP[$j]]);
				}
			}
		}
		
		
		$Interm=array();
		foreach($metabolites as $cle=>$valeur) if (!(isset($Entrees[$cle]) || isset($Sorties[$cle]))) $Interm[$cle]=1;

		$i=0; $j=0;
		$allvalues=array();
		$allvaluesexcept=array();
		foreach($Interm as $cle=>$valeur) {
			$allvalues[]=$cle;
			$allvaluesexcept[]=$cle;
		}
		foreach($Sorties as $cle=>$valeur) {
			$allvalues[]=$cle;
			$allvaluesexcept[]=$cle;
		}
		foreach($Entrees as $cle=>$valeur) {
			$allvalues[]=$cle;
		}
		
		$B=new Matrice();
		
		for($i=0; $i<count($allvaluesexcept); $i++) {
			$cle=$allvaluesexcept[$i];
			for($j=0; $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				if ($i == $j) $somme=1;
				else {
					$somme=0;
					for($k=0; $k<count($R[$cle]); $k++) {if ($F[$cle2] != 0) $somme+= $this->Solution[$R[$cle][$k]+1] * min(0,$this->matrice_stoechiometrique[$R[$cle][$k]][$cle2]) * $inr[$R[$cle][$k]][$cle]/$F[$cle2];}
				}
				$D->Set($i,$j,$somme);
			}
		}
		
		$X=array();
		foreach($F as $cle=>$valeur) 
			$X[$cle]=$valeur*$metaboliteWeights[$cle];

//print_r($metaboliteWeights);
//print_r($allvalues);

//		$D->printMatrice();
		
		$D->GAUSS($B);
//printf("---------\n");
//		$D->printMatrice();
//printf("---------\n");
		

//		foreach($metabolites as $cle=>$valeur) printf("%s => %s\n",$this->noms_colonnes[$cle],$valeur);
//		print_r($F);
//		print_r($Entrees);
//		print_r($Sorties);

// A faire : special case for CO2 output

if ($printformulas) {
	echo "<h2>Explicit relations</h2><pre>";
// Explicit relations
		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
//		for($i=0; $i<count($allvalues); $i++) {

			$cle=$allvalues[$i];
			$ch="X_".$this->noms_colonnes[$cle]." = ";
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
//			for($j=0; $j<count($allvalues); $j++) {
			if ($i!=$j) {
				$cle2=$allvalues[$j];
				if ($D->Get($i,$j) != 0) $ch=sprintf("%s +%.3f X_%s",$ch,-$D->Get($i,$j),$this->noms_colonnes[$cle2]);
			}
			}
			printf("%s\n",$ch);
		}
		
		echo "</pre>";
}


if ($printraw) {
	echo "<h2>Raw distribution</h2><style type=\"text/css\">th {background-color: lightblue;} td {text-align: right;} td.zero {color: #BBBBBB;}</style>";
		
		// Print the raw distribution
		
		echo "<table border=1>";
		echo "<tr><th>OUT\\IN</th>";
		for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
			$cle2=$allvalues[$j];
			printf("<th>%s</th>",$this->noms_colonnes[$cle2]);
		}
		echo "</tr>";
		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
			$cle=$allvalues[$i];
			$res="<th>".$this->noms_colonnes[$cle]."</th>";
			$ch="X_".$this->noms_colonnes[$cle]." = ";
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				$res=$res."<td ".(((-$D->Get($i,$j)*$X[$cle2]) != 0)?"":" class=\"zero\"").">".sprintf("%.2f",-$D->Get($i,$j)*$X[$cle2])."</td>";
			}
			printf("<tr>%s</tr>\n",$res);
		}
		echo "</table>";
}

if ($printbycols) {
	echo "<h2>Distribution percentage on inputs</h2><style type=\"text/css\">th {background-color: lightblue;} td {text-align: right;} td.zero {color: #BBBBBB;}</style>";
		
		// Print the distribution (percentage of inputs)
		$sums=array();
		echo "<table border=1>";
		echo "<tr><th>OUT\\IN</th>";
		for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
			$cle2=$allvalues[$j];
			printf("<th>%s</th>",$this->noms_colonnes[$cle2]);
		}
		echo "</tr>";
		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
			$cle=$allvalues[$i];
			$res="<th>".$this->noms_colonnes[$cle]."</th>";
			$ch="X_".$this->noms_colonnes[$cle]." = ";
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				if (isset($sums[$cle])) $sums[$cle]+=-$D->Get($i,$j)*$X[$cle2]; else $sums[$cle]=-$D->Get($i,$j)*$X[$cle2];
				$res=$res."<td ".((($D->Get($i,$j)) != 0)?"":" class=\"zero\"").">".sprintf("%.2f",-$D->Get($i,$j)*100)."</td>";
			}
			printf("<tr>%s</tr>\n",$res);
		}
		echo "</table>";
}

		
if ($printbycols) {
	echo "<h2>Distribution percentage on outputs</h2><style type=\"text/css\">th {background-color: lightblue;} td {text-align: right;} td.zero {color: #BBBBBB;}</style>";
		// Print the distribution (percentage of outputs)
		
		echo "<table border=1>";
		echo "<tr><th>OUT\\IN</th>";
		for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
			$cle2=$allvalues[$j];
			printf("<th>%s</th>",$this->noms_colonnes[$cle2]);
		}
		echo "</tr>";
		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
			$cle=$allvalues[$i];
			$res="<th>".$this->noms_colonnes[$cle]."</th>";
			$ch="X_".$this->noms_colonnes[$cle]." = ";
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				$res=$res."<td ".(((-$D->Get($i,$j)*$X[$cle2]) != 0)?"":" class=\"zero\"").">".sprintf("%.2f",(($sums[$cle]!=0)?(-$D->Get($i,$j)*$X[$cle2]*100/$sums[$cle]):0))."</td>";
			}
			printf("<tr>%s</tr>\n",$res);
		}
		echo "</table>";
		
		// return the raw distribution
}

		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				$D->Set($i,$j,-$D->Get($i,$j)*$X[$cle2]);
			}
		}
		return $D;


	}
	
	function getPartitionSage(& $inr, &$metaboliteWeights, $printraw, $printformulas, $printbycols, $printbyrows) {
		$Entrees=array();
		$Sorties=array();
		$Reactions=array();
		$REntrees=array();
		$RSorties=array();
		$RIntern=array();
		$metabolitesP=array();
		$metabolitesC=array();
		$metabolites=array();
		$rid=array();
		$D=new Matrice();
		$R=array();
		for($i=0; $i<count($this->types_colonnes); $i++) {
			switch ($this->types_colonnes[$i]) {
				case 3: $metabolitesP[]=$i; $metabolites[$i]="I"; $R[$i]=array(); break;
				case 5: 
					$metabolitesP[]=$i; $metabolites[$i]="M"; $R[$i]=array(); break;
				case 4: $metabolitesP[]=$i;  break;
//				case 8: $metabolitesC[]=$i; break;
				case 8: $metabolitesP[]=$i; $metabolites[$i]="I"; $R[$i]=array(); break;
			}
		}
		
		$R=array();
		for($i=0; $i<count($this->equations_utilisees)-1; $i++) { // rustine
			if ($this->equations_utilisees[$i+1] == "on") {
				$rid[]=$i;
				$flagE=false;
				$flagS=false;
				for($j=0; $j<count($metabolitesP);$j++) {
					if ($this->matrice_stoechiometrique[$i][$metabolitesP[$j]]<0) 
						{$flagS=true;}
					if ($this->matrice_stoechiometrique[$i][$metabolitesP[$j]]>0) 
						{$flagE=true; $R[$metabolitesP[$j]][]=$i; } //$this->matrice_stoechiometrique[$i][0]; }
				}
//				echo "RR ".$i."=".$flagE.",".$flagS."\n";
				if ($flagE && !$flagS) {$REntrees[]=$i;}
				else if ($flagS && !$flagE) {$RSorties[]=$i;} else {$RIntern[]=$i;}
				
			}
		}
		
//		print_r($RSorties);
		
		for ($i=0; $i<count($REntrees); $i++) {
			for($j=0; $j<count($this->matrice_stoechiometrique[$REntrees[$i]]); $j++) { 
				if (isset($metabolites[$j]) && ($this->matrice_stoechiometrique[$REntrees[$i]][$j]*1 > 0)) {
					$Entrees[$j]=1; $metabolites[$j].=" E_".$this->matrice_stoechiometrique[$REntrees[$i]][0];
				}
			}
		}
		
//		echo "<pre>";
		
		for ($i=0; $i<count($RSorties); $i++) {
			for($j=0; $j<count($this->matrice_stoechiometrique[$RSorties[$i]]); $j++) { 
				if (isset($metabolites[$j]) && ($this->matrice_stoechiometrique[$RSorties[$i]][$j]*1 < 0)) {
					$Sorties[$j]=1; $metabolites[$j].=" S_".$this->matrice_stoechiometrique[$RSorties[$i]][0];
					
//					echo $this->noms_colonnes[$j]." sortie a cause de ".$this->matrice_stoechiometrique[$RSorties[$i]][0]."\n";
				}
			}
		}

//		echo "</pre>";

		
		// suppression des fausse entrées sorties ici
		foreach($Sorties as $cle=>$valeur) if (isset($Entrees[$cle]) && ($Entrees[$cle] == $valeur)) {$Entrees[$cle]=0; $Sorties[$cle]=0; 
		}
		
		$F=array();
		for($j=0; $j<count($metabolitesP);$j++) {
			$F[$metabolitesP[$j]]="";
			for($i=0; $i<count($this->equations_utilisees)-1; $i++) { // rustine
				if ($this->equations_utilisees[$i+1] == "on") {
					$val=max(0,$this->matrice_stoechiometrique[$i][$metabolitesP[$j]]);
					if ($val != 0)
						$F[$metabolitesP[$j]].="+ v".($i+1)." * ".$val;
				}
			}
		}
				
		$Interm=array();
		foreach($metabolites as $cle=>$valeur) if (!(isset($Entrees[$cle]) || isset($Sorties[$cle]))) $Interm[$cle]=1;

		$i=0; $j=0;
		$allvalues=array();
		$allvaluesexcept=array();
		foreach($Interm as $cle=>$valeur) {
			$allvalues[]=$cle;
			$allvaluesexcept[]=$cle;
		}
		foreach($Sorties as $cle=>$valeur) {
			$allvalues[]=$cle;
			$allvaluesexcept[]=$cle;
		}
		foreach($Entrees as $cle=>$valeur) {
			$allvalues[]=$cle;
		}
		
		$B=new Matrice();
		
		
		$D=array();
		for($i=0; $i<count($allvaluesexcept); $i++) {
			$cle=$allvaluesexcept[$i];
			for($j=0; $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				if ($i == $j) $somme="1";
				else {
					$somme="";
					for($k=0; $k<count($R[$cle]); $k++) {if ($F[$cle2] != "" && (min(0,$this->matrice_stoechiometrique[$R[$cle][$k]][$cle2])!=0) && isset($inr[$R[$cle][$k]][$cle])) $somme.= " + v".($R[$cle][$k]+1)." * ".min(0,$this->matrice_stoechiometrique[$R[$cle][$k]][$cle2])." * ".$inr[$R[$cle][$k]][$cle]."/(".$F[$cle2].")";}
				}
//				$D[$this->noms_colonnes[$cle].",".$this->noms_colonnes[$cle2]]=($somme != "")?$somme:"0";
				$D[$i.",".$j]=($somme != "")?$somme:"0";
			}
		}
		
		
		$X=array();
		foreach($F as $cle=>$valeur) 
			if ($metaboliteWeights[$cle] != 0) $X[$cle]="(".$valeur.")*".$metaboliteWeights[$cle]; else $X[$cle]="0";

//print_r($metaboliteWeights);
//print_r($allvalues);

//		$D->printMatrice();
		echo "<pre>F\n-------------\n";
		foreach($F as $cle=>$valeur) {
			echo "F[".$this->noms_colonnes[$cle]."]=".$valeur."\n";
		}
		echo "</pre>";
		echo "<pre>Variables\n-------------\n";
		$res="";
		$flag=false;
		for($i=0; $i<count($this->equations_utilisees)-1; $i++) { // rustine
			if ($this->equations_utilisees[$i+1] == "on") {
				if ($flag) $res.=" ";
				$flag=true;
				$res.="v".($i+1);
			}
		}
		
		
		printf("vars=var(\"%s\")\n\n",$res);
		/*
		$res="";
		for($i=0; $i<count($this->equations_utilisees)-1; $i++) { // rustine
			if ($this->equations_utilisees[$i+1] == "on") {
				if (isset($this->Entrees[$i+1]) && ($this->Entrees[$i+1]!=0)) $res.="v".($i+1)."=".$this->Entrees[$i+1]."\n";
				if (isset($this->Sorties[$i+1]) && ($this->Sorties[$i+1]!=0)) $res.="v".($i+1)."=".$this->Sorties[$i+1]."\n";
			}
		}
		printf("%s",$res);
		*/
		$this->ToEquations("tmp/equationsSortie.tmp");
		echo file_get_contents("tmp/equationsSortie.tmp");
		
		echo "</pre>";
		echo "<pre>D1\n-------------\n";
		$res="D1=Matrix(";
		$flag=false;
		for($i=0; $i<count($allvaluesexcept); $i++) {
			if ($flag) $res.=","; else $res.="[";
			$flag=true;
			$flag2=false;
			for($j=0; $j<count($allvaluesexcept); $j++) {
				if ($flag2) $res.=","; else $res.="[";
				$flag2=true;
				$res.=$D[$i.",".$j];
			}
			$res.="]";
		}
		$res.="])";
		
		printf("%s\n\n",$res);
		echo "</pre>";
		echo "<pre>D2\n-------------\n";
		$res="D2=Matrix(";
		$flag=false;
		for($i=0; $i<count($allvaluesexcept); $i++) {
			if ($flag) $res.=","; else $res.="[";
			$flag=true;
			$flag2=false;
			for($j=count($allvaluesexcept); $j<count($allvalues); $j++) {
				if ($flag2) $res.=","; else $res.="[";
				$flag2=true;
				$res.=$D[$i.",".$j];
			}
			$res.="]";
		}
		$res.="])";
		
		printf("%s\n\n",$res);
		printf("table=-D1.inverse()*D2\n");

		printf("Taille(D1)=%dx%d, Taille(D1)=%dx%d\n",count($allvaluesexcept),count($allvaluesexcept),count($allvaluesexcept),count($allvalues)-count($allvaluesexcept));
		for($i=count($Interm); $i<count($allvaluesexcept); $i++) {
			for($j=count($allvaluesexcept); $j<count($allvalues); $j++) {
				echo "print table[".$i.",".($j-count($allvaluesexcept))."]\n";
			}
		}
			
		
		
		
		
		
		
		echo "</pre>";
		echo "<pre>B\n-------------\n";
		print_r($B);
		echo "</pre>";
		echo "<pre>X\n-------------\n";
		foreach($X as $cle=>$valeur) {
			echo "X[".$this->noms_colonnes[$cle]."]=".$valeur."\n";
		}
		echo "</pre>";
	}
	
	function getPartitionLatex(& $inr, &$metaboliteWeights, $printraw, $printformulas, $printbycols, $printbyrows) {
		$Entrees=array();
		$Sorties=array();
		$Reactions=array();
		$REntrees=array();
		$RSorties=array();
		$RIntern=array();
		$metabolitesP=array();
		$metabolitesC=array();
		$metabolites=array();
		$rid=array();
		$D=new Matrice();
		$R=array();
		for($i=0; $i<count($this->types_colonnes); $i++) {
			switch ($this->types_colonnes[$i]) {
				case 3: $metabolitesP[]=$i; $metabolites[$i]="I"; $R[$i]=array(); break;
				case 5: 
					$metabolitesP[]=$i; $metabolites[$i]="M"; $R[$i]=array(); break;
				case 4: $metabolitesP[]=$i;  break;
//				case 8: $metabolitesC[]=$i; break;
				case 8: $metabolitesP[]=$i; $metabolites[$i]="I"; $R[$i]=array(); break;
			}
		}
		
		$R=array();
		for($i=0; $i<count($this->equations_utilisees)-1; $i++) { // rustine
			if ($this->equations_utilisees[$i+1] == "on") {
				$rid[]=$i;
				$flagE=false;
				$flagS=false;
				for($j=0; $j<count($metabolitesP);$j++) {
					if ($this->matrice_stoechiometrique[$i][$metabolitesP[$j]]<0) 
						{$flagS=true;}
					if ($this->matrice_stoechiometrique[$i][$metabolitesP[$j]]>0) 
						{$flagE=true; $R[$metabolitesP[$j]][]=$i; } //$this->matrice_stoechiometrique[$i][0]; }
				}
//				echo "RR ".$i."=".$flagE.",".$flagS."\n";
				if ($flagE && !$flagS) {$REntrees[]=$i;}
				else if ($flagS && !$flagE) {$RSorties[]=$i;} else {$RIntern[]=$i;}
				
			}
		}
		
//		print_r($RSorties);
		
		for ($i=0; $i<count($REntrees); $i++) {
			for($j=0; $j<count($this->matrice_stoechiometrique[$REntrees[$i]]); $j++) { 
				if (isset($metabolites[$j]) && ($this->matrice_stoechiometrique[$REntrees[$i]][$j]*1 > 0)) {
					$Entrees[$j]=1; $metabolites[$j].=" E_".$this->matrice_stoechiometrique[$REntrees[$i]][0];
				}
			}
		}
		
		echo "<pre>";
		
		for ($i=0; $i<count($RSorties); $i++) {
			for($j=0; $j<count($this->matrice_stoechiometrique[$RSorties[$i]]); $j++) { 
				if (isset($metabolites[$j]) && ($this->matrice_stoechiometrique[$RSorties[$i]][$j]*1 < 0)) {
					$Sorties[$j]=1; $metabolites[$j].=" S_".$this->matrice_stoechiometrique[$RSorties[$i]][0];
					
//					echo $this->noms_colonnes[$j]." sortie a cause de ".$this->matrice_stoechiometrique[$RSorties[$i]][0]."\n";
				}
			}
		}

		echo "</pre>";

		
		// suppression des fausse entrées sorties ici
		foreach($Sorties as $cle=>$valeur) if (isset($Entrees[$cle]) && ($Entrees[$cle] == $valeur)) {$Entrees[$cle]=0; $Sorties[$cle]=0; 
		}
		
		$F=array();
		for($j=0; $j<count($metabolitesP);$j++) {
			$F[$metabolitesP[$j]]=0;
			for($i=0; $i<count($this->equations_utilisees)-1; $i++) { // rustine
				if ($this->equations_utilisees[$i+1] == "on") {
					$F[$metabolitesP[$j]]+=$this->Solution[$i+1] * max(0,$this->matrice_stoechiometrique[$i][$metabolitesP[$j]]);
				}
			}
		}
		
		
		$Interm=array();
		foreach($metabolites as $cle=>$valeur) if (!(isset($Entrees[$cle]) || isset($Sorties[$cle]))) $Interm[$cle]=1;

		$i=0; $j=0;
		$allvalues=array();
		$allvaluesexcept=array();
		foreach($Interm as $cle=>$valeur) {
			$allvalues[]=$cle;
			$allvaluesexcept[]=$cle;
		}
		foreach($Sorties as $cle=>$valeur) {
			$allvalues[]=$cle;
			$allvaluesexcept[]=$cle;
		}
		foreach($Entrees as $cle=>$valeur) {
			$allvalues[]=$cle;
		}
		
		$B=new Matrice();
		
		for($i=0; $i<count($allvaluesexcept); $i++) {
			$cle=$allvaluesexcept[$i];
			for($j=0; $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				if ($i == $j) $somme=1;
				else {
					$somme=0;
					for($k=0; $k<count($R[$cle]); $k++) {if ($F[$cle2] != 0) $somme+= $this->Solution[$R[$cle][$k]+1] * min(0,$this->matrice_stoechiometrique[$R[$cle][$k]][$cle2]) * $inr[$R[$cle][$k]][$cle]/$F[$cle2];}
				}
				$D->Set($i,$j,$somme);
			}
		}
		
		$X=array();
		foreach($F as $cle=>$valeur) 
			$X[$cle]=$valeur*$metaboliteWeights[$cle];

//print_r($metaboliteWeights);
//print_r($allvalues);

//		$D->printMatrice();
		
		$D->GAUSS($B);
//printf("---------\n");
//		$D->printMatrice();
//printf("---------\n");
		

//		foreach($metabolites as $cle=>$valeur) printf("%s => %s\n",$this->noms_colonnes[$cle],$valeur);
//		print_r($F);
//		print_r($Entrees);
//		print_r($Sorties);

// A faire : special case for CO2 output

if ($printformulas) {
// Explicit relations
		echo "<pre>";
		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
//		for($i=0; $i<count($allvalues); $i++) {

			$cle=$allvalues[$i];
			$ch="X_{".$this->noms_colonnes[$cle]."} = ";
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
//			for($j=0; $j<count($allvalues); $j++) {
			if ($i!=$j) {
				$cle2=$allvalues[$j];
				if ($D->Get($i,$j) != 0) $ch=sprintf("%s +%.3f X_{%s}",$ch,-$D->Get($i,$j),$this->noms_colonnes[$cle2]);
			}
			}
			printf("$$%s$$\n",$ch);
		}
		
		echo "</pre>";
}


if ($printraw) {
	echo "<pre>";

	echo "Raw distribution\n";
		
		// Print the raw distribution
		
		echo "\\begin{tabular}{lccccccc}\n";
		echo "\\hline\n";
		echo "OUT/IN";
		for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
			$cle2=$allvalues[$j];
			printf("&%s",$this->noms_colonnes[$cle2]);
		}
		echo "\\\\\n\\hline\n";
		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
			$cle=$allvalues[$i];
			$res="".$this->noms_colonnes[$cle]."";
			$ch="X_".$this->noms_colonnes[$cle]." = ";
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				$res=$res."".sprintf("&%.2f",-$D->Get($i,$j)*$X[$cle2])."";
			}
			printf("%s\\\\\n\\hline\n",$res);
		}
		echo "\\end{tabular}\n";
		echo "</pre>";
}

if ($printbycols) {
	echo "<pre>";
	echo "Distribution percentage on inputs\n";
		echo "\\begin{tabular}{lccccccc}\n";
		echo "\\hline\n";
		echo "OUT/IN";
			
		// Print the distribution (percentage of inputs)
		$sumsi=array();
		$sums=array();
		for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
			$cle2=$allvalues[$j];
			printf("&%s",$this->noms_colonnes[$cle2]);
			$sumsi[$cle2]=0;
		}
		echo "\\\\\n\\hline\n";
		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
			$cle=$allvalues[$i];
			$res="".$this->noms_colonnes[$cle]."";
			$ch="X_".$this->noms_colonnes[$cle]." = ";
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				if (isset($sumsi[$cle2])) $sumsi[$cle2]+=-$D->Get($i,$j)*$X[$cle2]; else $sumsi[$cle2]=-$D->Get($i,$j)*$X[$cle2];
				if (isset($sums[$cle])) $sums[$cle]+=-$D->Get($i,$j)*$X[$cle2]; else $sums[$cle]=-$D->Get($i,$j)*$X[$cle2];
				$res=$res."".sprintf("&%.2f",-$D->Get($i,$j)*100)."";

			}
			printf("%s\\\\\n\\hline\n",$res);
		}
		echo "\\end{tabular}\n";
		for($i=count($Interm)+count($Sorties); $i<count($allvalues); $i++) {
			$cle2=$allvalues[$i];
			printf("Entree %s = %f\n",$this->noms_colonnes[$cle2],$sumsi[$cle2]);
		}		
		for($j=count($Interm); $j<count($Interm)+count($Sorties); $j++) {
			$cle2=$allvalues[$j];
			printf("Sorties %s = %f\n",$this->noms_colonnes[$cle2],$sums[$cle2]);
		}
		echo "</pre>";
}

		
if ($printbycols) {
	echo "<pre>";
	echo "Distribution percentage on outputs\n";
		echo "\\begin{tabular}{lccccccc}\n";
		echo "\\hline\n";
		echo "OUT/IN";
		$sums=array();
		for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
			$cle2=$allvalues[$j];
			printf("&%s",$this->noms_colonnes[$cle2]);
		}
		echo "\\\\\n\\hline\n";
		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
			$cle=$allvalues[$i];
			$res="".$this->noms_colonnes[$cle]."";
			$ch="X_".$this->noms_colonnes[$cle]." = ";
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				$res=$res."".sprintf("&%.2f",(($sums[$cle]!=0)?(-$D->Get($i,$j)*$X[$cle2]*100/$sums[$cle]):0))."";
			}
			printf("%s\\\\\n\\hline\n",$res);
		}
		echo "\\end{tabular}\n";
		echo "</pre>";
		
		// return the raw distribution
}

		for($i=count($Interm); $i<count($Interm)+count($Sorties); $i++) {
			for($j=count($Interm)+count($Sorties); $j<count($allvalues); $j++) {
				$cle2=$allvalues[$j];
				$D->Set($i,$j,-$D->Get($i,$j)*$X[$cle2]);
			}
		}
		return $D;


	}
	

	function CreateGraph($filename=STDOUT) {
		$fd=fopen($filename,"w");
		fprintf($fd,"digraph G {\n");
        fprintf($fd,"\tsize=\"30.5,30.5\"; \n ");
                 

		for($i=0; $i<count($this->types_colonnes); $i++) {
			switch ($this->types_colonnes[$i]) {
				case 3:
                               // case 4: //////////
				case 5:
			
                        	fprintf($fd,"\tMI%s [label=\"%s\", shape=\"rect\", style=\"filled\", fillcolor=\"#AAAAFF\"];\n",$i,$this->noms_colonnes[$i]);
                              //  break;
                              //  case 4:
                              //  fprintf($fd, "\tMI%s [label=\"%s\", shape=\"ellipse\", style=\"filled\", fillcolor=\"red\"];\n",$i,$this->noms_colonnes[$i]);
                        
			}
		}

		for($i=1; $i<count($this->equations_utilisees); $i++) {
			//fprintf($fd,">>>%s , %d\n",$this->equations_utilisees[$i],$this->Solution[$i]);
			if (($this->equations_utilisees[$i] == "on") && ($this->Solution[$i] != 0)) {
		        	//$label="\"eq ".$i."\\ncoeff=".$this->Solution[$i]."\\n";
                                $label="\"eq ".$i."\\n";
				for($k=0; $k<count($this->types_colonnes); $k++) {
					switch ($this->types_colonnes[$k]) {
                                                case 4:
						case 6:
						case 7:
					        case 8:
					        case 9:
					        case 10:
						$label.=$this->noms_colonnes[$k]."=".($this->matrice_stoechiometrique[$i-1][$k]*$this->Solution[$i])."\\n";
                                                break;
                                                case 3:
                                              //  case 4: //////////
						case 5:
						if ($this->matrice_stoechiometrique[$i-1][$k] > 0) {
						$label.=$this->noms_colonnes[$k]."=".($this->matrice_stoechiometrique[$i-1][$k]*$this->Solution[$i])."\\n";	
						} else if ($this->matrice_stoechiometrique[$i-1][$k] < 0) {
						$label.=$this->noms_colonnes[$k]."=".($this->matrice_stoechiometrique[$i-1][$k]*$this->Solution[$i])."\\n";	
						}
					}
				}
				$label.="\"";

				fprintf($fd,"\tR%s [label=%s, style=\"filled\", fillcolor=\"%s\"];\n",$i,
					$label,
					"#FFAAAA"); //:(($matrice[$Equations[$i]][2]=="output")?"#FFAAFF":"#FFFFFF"));
				$left="";
				$right="";
				$ligne=$this->matrice_stoechiometrique[$i];
				$nbext=0;
				for($k=0; $k<count($this->types_colonnes); $k++) {
					switch ($this->types_colonnes[$k]) {
						case 3:
                                              //  case 4: ///////////
						case 5:
						if ($this->matrice_stoechiometrique[$i-1][$k] > 0) {
							$nbext++;
							fprintf($fd,"\t R%d -> MI%d [penwidth=\"2\"];\n",$i,$k);
						} else if ($this->matrice_stoechiometrique[$i-1][$k] < 0) {
							fprintf($fd,"\t MI%d -> R%d [color=\"red\", penwidth=\"2\"];\n",$k,$i);
						}
					}
				}

				if ($nbext == 0) fprintf($fd,"\t R%s -> R%s;\n",$i,$i);
			}
		}

		fprintf($fd,"}\n");
		fclose($fd);
	}


function getIdReact($i,$indice) {
	return ($indice == -1)?$i:$this->matrice_stoechiometrique[$i][$indice];
}

function contientPivot($unterme,&$correspPivots) {
	foreach($correspPivots as $cle=>$valeur) {
//		printf("%s contient %s ?\n",$unterme,$cle);
		if (strpos(" ".$unterme,$cle) !== false ) return true;
	}
	return false;
}

function ArithmToArray($droite, & $reactionsId,&$correspPivots) {
	$expression=array();
	$expression["CONST"] = 0;
	$expression["TERMES"] = array();
	$signecourant=1;
	$Tab=explode(" ",$droite);
//	printf("->%s\n",$droite);
//	print_r($Tab);
    for($i=0; $i<count($Tab); $i++) {
		$unterme=$Tab[$i];		
		//est-ce que c'est un signe ?
		if (($unterme == "+") || ($unterme == "-")) $signecourant=($unterme == "+")?1:-1;
		else {
			// est-ce une constante ? (R_ est present ?)
//			printf("%s est une constante ? %d\n",$unterme, ! $this->contientPivot($unterme,$correspPivots));
			if ((strpos(" ".$unterme,"r_") === false) && (! $this->contientPivot($unterme,$correspPivots ))) {
				 $expression["CONST"] -= $unterme*$signecourant;
			} else {
				// C'est donc un vrai terme, est-ce qu'il a un coeff ?
				if (strpos(" ".$unterme,"*") === false)
					$coeff=1; //$signecourant;
				else list($coeff,$unterme)=explode("*",$unterme);
				$coeff*=$signecourant;
				
				// pivot ou réaction ?
				if (strpos(" ".$unterme,"r_") === false) {
					$valeurs=$correspPivots[$unterme];
//					printf("Traitement de %s\n",$unterme);
//					print_r($valeurs);
					for($t=0; $t<count($valeurs); $t++) {
						// problème de correspondance entre indices et Id dans correspPivots.
						if ($valeurs[$t] != 0) {
						if (! isset($expression["TERMES"][$t]))
							$expression["TERMES"][$t]=-$coeff*$valeurs[$t];
						else
							$expression["TERMES"][$t]-=$coeff*$valeurs[$t];
						}						
					}
				} else {
						$unterme=substr($unterme,2);
						if (! isset($expression["TERMES"][$reactionsId[$unterme]]))
							$expression["TERMES"][$reactionsId[$unterme]]=-$coeff;
						else
							$expression["TERMES"][$reactionsId[$unterme]]-=$coeff;						
				}
                        
			}
		}
	}
	return $expression;
}

function Traitement($chaine, & $reactionsId, &$correspPivots) {
    // Prend en entrée une chaine représentant une expression et on l'analyse
    // On a droit à "r_numéro" ou "ATP"
	$Operateurs=array("<",">","=","maximize","minimize");
	$Operations=array("+","-");
        
	// Mise en minuscule
	$chaine=strtolower(trim($chaine));

	// suppression de tous les espaces pour mieux les ajouter ensuite
	$chaine=str_replace(" ","",$chaine);

	// découpage partie droite, partie gauche et récupération du type
	for($i=0; $i<count($Operateurs); $i++)
		$chaine=str_replace($Operateurs[$i]," ".$Operateurs[$i]." ",$chaine);
	list($gauche,$rel,$droite)=explode(" ",$chaine);
    /*
    echo "<pre>";
    printf( "%s : (%s , %s , %s)\n",$chaine,$gauche,$rel,$droite);
    echo "</pre>";
    */
    if ($gauche == "maximize" || $gauche == "minimize") {
    	$droite=$rel;
    	$rel=$gauche;
    	$gauche="";
    }
    
    $relation[]= $rel;
         // préparation au découpage des partie droites et gauches.
	for($i=0; $i<count($Operations); $i++) {               
		$droite=str_replace($Operations[$i]," ".$Operations[$i]." ",$droite);
        $gauche=str_replace($Operations[$i]," ".$Operations[$i]." ",$gauche);
	}
    
//	printf("->%s\n",$gauche);
      

	$expression=array("TYPE"=>$rel,"CONST"=>0, "TERMES"=>array());
	$tabgauche=$this->ArithmToArray($gauche, $reactionsId,$correspPivots);
	$tabdroite=$this->ArithmToArray($droite, $reactionsId,$correspPivots);
	$expression["CONST"]=$tabgauche["CONST"]-$tabdroite["CONST"];
	foreach($tabgauche["TERMES"] as $cle=>$valeur) {
		if (isset($expression["TERMES"][$cle])) $expression["TERMES"][$cle]-=$valeur; else $expression["TERMES"][$cle]=-$valeur; 
	}
	foreach($tabdroite["TERMES"] as $cle=>$valeur) {
		if (isset($expression["TERMES"][$cle])) $expression["TERMES"][$cle]+=$valeur; else $expression["TERMES"][$cle]=$valeur; 
	}
//	print_r($expression);
    return $expression;
}


function ToLinearSystem($nomfich="") {
	// quel est le numéro d'identifiant
	// Récupération des colonnes d'intérêt
	$indicenoms=1;
	$indiceId=-1;
	$indicesMetabolites=array();
	for ($i=0; $i<count($this->types_colonnes); $i++) {
		switch ($this->types_colonnes[$i]) {
			case 2: $indiceId=$i; break;
			case 1: $indicenoms=$i; break;
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
				$indicesMetabolites[]=$i; break;
		}
	}
	// affichage des variables
	$ToutesContraintes=array();
	$ToutesContraintes["<"]=array();
	$ToutesContraintes[">"]=array();
	$ToutesContraintes["="]=array();
	$ToutesContraintes["m"]=array();
	$ToutesContraintes["M"]=array();
	
	$reactionsUtilisees=array();
	$reactionsId=array();
	$rustine=1;
//	echo "<pre>";
	for ($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
		if ($this->equations_utilisees[$i+$rustine] == "on") {$reactionsUtilisees[]=$i;
			if ($this->Entrees[$i+$rustine] != "" && $this->Entrees[$i+$rustine] != "0") {
//					echo "  Egalité v_".$this->getIdReact($i,$indiceId)."=".$this->Entrees[$i+$rustine]." -- ".($i+$rustine)."\n";
			} else {
				if ($this->Sorties[$i+$rustine] != "" && $this->Sorties[$i+$rustine] != "0") {
//					echo "  Egalité v_".$this->getIdReact($i,$indiceId)."=".$this->Sorties[$i+$rustine]." -- ".($i+$rustine)."\n";
				} else {
//					echo "  Inégalité 0<=v_".$this->getIdReact($i,$indiceId)."<=100000000"." -- ".($i+$rustine)."\n";
				}
			}
		} // rustine décalage entre equations utilisées et matrice stoechiométrique !!!
		$reactionsId[$this->getIdReact($i,$indiceId)]=$i;
	}

/*
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
		$AAfficher="R_".$this->getIdReact($reaction-$rustine,$indiceId).":";
		$left="";
		$right="";
		for ($k=0; $k<count($this->noms_colonnes); $k++) {
			$valeur=$this->matrice_stoechiometrique[$reaction-$rustine][$k]*1;
			if (($this->types_colonnes[$k] >= 3) && ($this->types_colonnes[$k] <= 7) && ($valeur != 0)) {
			if ($valeur<0) {
				$left.=" +".abs($valeur)."*".$this->noms_colonnes[$k];
			} else {
				$right.=" +".abs($valeur)."*".$this->noms_colonnes[$k];
			}
			}
		}
		printf("%s %s => %s\n",$AAfficher,$left,$right);

	} 
*/
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
			if ($this->Entrees[$reaction] != "" && $this->Entrees[$reaction] != "0") {
					$res="=;".$this->Entrees[$reaction];
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["="][]=$res;
			} else {
				if ($this->Sorties[$reaction] != "" && $this->Sorties[$reaction] != "0") {
					$res="=;".$this->Sorties[$reaction];
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["="][]=$res;
				} else {
					$res=">;0";
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes[">"][]=$res;
					$res="<;1000000000000";
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["<"][]=$res;
				}
			}
		} 
	

/*	$res=";variables";
	for ($i=0; $i<count($reactionsUtilisees); $i++) {
		$res.="; R".$this->getIdReact($reactionsUtilisees[$i],$indiceId);
	}
	*/
//	printf("%s\n",$res);
	
	// Bornes inf sur les coefficients
/*	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$res=">;0";
		for ($i=0; $i<count($reactionsUtilisees); $i++) {
			if ($i == $j) $res.="; 1"; else $res.="; 0";
		}
		$ToutesContraintes[">"][]=$res;
	}
*/	
	// Bornes sup sur les coefficients
/*	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$res="<;1000000000";
		for ($i=0; $i<count($reactionsUtilisees); $i++) {
			if ($i == $j) $res.="; 1"; else $res.="; 0";
		}
		$ventree=$this->Entrees[$reactionsUtilisees[$j]+1];
		$vsortie=$this->Sorties[$reactionsUtilisees[$j]+1];
		if (($ventree == "" || $ventree*1 == 0) && ($vsortie == "" || $vsortie*1 == 0)) $ToutesContraintes["<"][]=$res;
	}
*/
	// Contraintes d'entrée
	//print_r($reactionsUtilisees);
	
	// attention, il faut éviter les contraintes vides...
	/*
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$indi=$reactionsUtilisees[$j]+1; // rustine
		if (($this->Entrees[$indi]*1 != 0) && ($this->Entrees[$indi] != "")) { // il faut discuter de ce test !
			$res="=;".$this->Entrees[$indi];
			$flag=false;
			for ($i=0; $i<count($reactionsUtilisees); $i++) {
				if ($i == $j) {$res.="; 1"; $flag=true;} else $res.="; 0";
			}
//			printf("%s\n",$res);
			if ($flag) $ToutesContraintes["="][]=$res;
		}
	}
*/
	// Contraintes de sortie
/*	
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$indi=$reactionsUtilisees[$j]+1; // rustine
		if (($this->Sorties[$indi]*1 != 0) && ($this->Sorties[$indi] != "")) { // il faut discuter de ce test !
			$res="=;".$this->Sorties[$indi];
			$flag=false;
			for ($i=0; $i<count($reactionsUtilisees); $i++) {
				if ($i == $j) {$res.="; 1"; $flag=true;} else $res.="; 0";
			}
//			printf("%s\n",$res);
			if ($flag) $ToutesContraintes["="][]=$res;
		}
	}
*/	
	// Contraintes supplémentaires
	
	// Premier travail, on exprime tous les noms de colonnes comme des combinaisons des variables (ici on ne distingue pas le type de la colonne, ce serait évidemment à faire normalement).
	$correspPivots=array();
	for ($j=0; $j<count($this->noms_colonnes); $j++) {
		$res=array();
		for ($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$res[]=$this->matrice_stoechiometrique[$i][$j];
		}
		$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$j]))]=$res; // mise en minuscule et suppression des espaces	
	} // avec ça, on doit pouvoir écrire des contraintes du type ATP=0...

//print_r($correspPivots["glc"]);

	// Contraintes sur les pivots (type = 3)
	
//	print_r($correspPivots);
	
	for ($k=0; $k<count($this->noms_colonnes); $k++) {
		if (($this->types_colonnes[$k] >= 3) && ($this->types_colonnes[$k] <= 5)) {
			$res="=;".(($this->types_colonnes[$k] == 3)?0:$this->Entrees_Sorties[$k]);
			$AAfficher=(($this->types_colonnes[$k] == 3)?0:$this->Entrees_Sorties[$k])."=";
			$tab=$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$k]))];
			$flag=false;
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$reactionsUtilisees[$j];
				$res.=";".$tab[$indi];
				if ($tab[$indi]*1 != 0) {
					$flag=true;
					$AAfficher.=(($tab[$indi]*1 > 0)?"+".$tab[$indi]:$tab[$indi])."v_".$this->getIdReact($indi,$indiceId)." ";
				}
			}
//			printf("%s -- %s\n",$AAfficher,$this->noms_colonnes[$k]);
			if ($flag) $ToutesContraintes["="][]=$res;
		}
	}
//printf("<pre>");

	// contraintes supplémentaires
	for ($i=0; $i<count($this->contraintes); $i++) {
		// Tester si c'est une contrainte...
		if ((trim($this->contraintes[$i]) != "") && (trim($this->contraintes[$i]) != "0")) {
			$cont=$this->Traitement($this->contraintes[$i],$reactionsId,$correspPivots);
			$signe=1;
			if ($cont["TYPE"] == "maximize") {$cont["TYPE"] = "m"; $signe=-1;}
			if ($cont["TYPE"] == "minimize") {$cont["TYPE"] = "m"; $signe=1;}
			if ($cont["CONST"] < 0) {$cont["CONST"] = -$cont["CONST"]; $signe=-$signe;}
			$res=$cont["TYPE"].";".$cont["CONST"];
			$AAfficher=$cont["CONST"].$cont["TYPE"];
//			print_r($cont);
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$this->getIdReact($reactionsUtilisees[$j],$indiceId);
				if (isset($cont["TERMES"][$indi-$rustine])) {
					$res.=";".($signe*($cont["TERMES"][$indi-$rustine]));
					$valeur=$signe*($cont["TERMES"][$indi-$rustine]);
					$AAfficher.=(($valeur > 0)?"+".$valeur:$valeur)."v_".$indi." ";

				} else $res.=";0";
			}
//			printf("%s\n",$AAfficher);
			$ToutesContraintes[$cont["TYPE"]][]=$res;		
		}
	}
	// objectif on suppose qu'il y en a un seul
	
	for ($k=0; $k<count($this->noms_colonnes); $k++) {
		if (($this->types_colonnes[$k] >= 6) && ($this->types_colonnes[$k] <= 7)) {
			$res="m;0"; $signe=(($this->types_colonnes[$k] == 6)?1:-1);
			$tab=$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$k]))];
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$reactionsUtilisees[$j];
				$res.=";".$tab[$indi]*$signe;
			}
//			printf("%s\n",$res);
			$ToutesContraintes["m"][]=$res;
		}
	}
	

// Reste les contraintes supplémentaires	
//		print_r($ToutesContraintes);
//      printf("</pre>");
	if ($nomfich == "") $fd=STDOUT; else $fd=fopen($nomfich,"w");
	$tabop=array("<","=","m");
	for($cle=0;$cle<count($tabop);$cle++) {
		$valeur=$tabop[$cle];
		for($i=0; $i<count($ToutesContraintes[$valeur]);$i++) {
			fprintf($fd,"%s;\n",$ToutesContraintes[$valeur][$i]);
		}
	}
	if ($nomfich != "") fclose($fd);
}

function ToEquations($nomfich="") {
	// quel est le numéro d'identifiant
	// Récupération des colonnes d'intérêt
	$indicenoms=1;
	$indiceId=-1;
	$indicesMetabolites=array();
	for ($i=0; $i<count($this->types_colonnes); $i++) {
		switch ($this->types_colonnes[$i]) {
			case 2: $indiceId=$i; break;
			case 1: $indicenoms=$i; break;
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
				$indicesMetabolites[]=$i; break;
		}
	}
	// affichage des variables
	$ToutesContraintes=array();
	$ToutesContraintes["<"]=array();
	$ToutesContraintes[">"]=array();
	$ToutesContraintes["="]=array();
	$ToutesContraintes["m"]=array();
	$ToutesContraintes["M"]=array();
	
	$reactionsUtilisees=array();
	$reactionsId=array();
	$rustine=1;
//	echo "<pre>";
	for ($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
		if ($this->equations_utilisees[$i+$rustine] == "on") {$reactionsUtilisees[]=$i;
			if ($this->Entrees[$i+$rustine] != "" && $this->Entrees[$i+$rustine] != "0") {
//					echo "  Egalité v_".$this->getIdReact($i,$indiceId)."=".$this->Entrees[$i+$rustine]." -- ".($i+$rustine)."\n";
			} else {
				if ($this->Sorties[$i+$rustine] != "" && $this->Sorties[$i+$rustine] != "0") {
//					echo "  Egalité v_".$this->getIdReact($i,$indiceId)."=".$this->Sorties[$i+$rustine]." -- ".($i+$rustine)."\n";
				} else {
//					echo "  Inégalité 0<=v_".$this->getIdReact($i,$indiceId)."<=100000000"." -- ".($i+$rustine)."\n";
				}
			}
		} // rustine décalage entre equations utilisées et matrice stoechiométrique !!!
		$reactionsId[$this->getIdReact($i,$indiceId)]=$i;
	}

/*
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
		$AAfficher="R_".$this->getIdReact($reaction-$rustine,$indiceId).":";
		$left="";
		$right="";
		for ($k=0; $k<count($this->noms_colonnes); $k++) {
			$valeur=$this->matrice_stoechiometrique[$reaction-$rustine][$k]*1;
			if (($this->types_colonnes[$k] >= 3) && ($this->types_colonnes[$k] <= 7) && ($valeur != 0)) {
			if ($valeur<0) {
				$left.=" +".abs($valeur)."*".$this->noms_colonnes[$k];
			} else {
				$right.=" +".abs($valeur)."*".$this->noms_colonnes[$k];
			}
			}
		}
		printf("%s %s => %s\n",$AAfficher,$left,$right);

	} 
*/
	$FixedValues=array();
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
			if ($this->Entrees[$reaction] != "" && $this->Entrees[$reaction] != "0") {
					$res="=;".$this->Entrees[$reaction];
					$FixedValues[$j]=$this->Entrees[$reaction];
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["="][]=$res;
			} else {
				if ($this->Sorties[$reaction] != "" && $this->Sorties[$reaction] != "0") {
					$res="=;".$this->Sorties[$reaction];
					$FixedValues[$j]=$this->Sortie[$reaction];
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["="][]=$res;
				} else {
					$res=">;0";
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes[">"][]=$res;
					$res="<;1000000000000";
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["<"][]=$res;
				}
			}
		} 
	

	// Contraintes supplémentaires
	
	// Premier travail, on exprime tous les noms de colonnes comme des combinaisons des variables (ici on ne distingue pas le type de la colonne, ce serait évidemment à faire normalement).
	$correspPivots=array();
	for ($j=0; $j<count($this->noms_colonnes); $j++) {
		$res=array();
		for ($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$res[]=$this->matrice_stoechiometrique[$i][$j];
		}
		$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$j]))]=$res; // mise en minuscule et suppression des espaces	
	} // avec ça, on doit pouvoir écrire des contraintes du type ATP=0...

//print_r($correspPivots["glc"]);

	// Contraintes sur les pivots (type = 3)
	
//	print_r($correspPivots);
	
	for ($k=0; $k<count($this->noms_colonnes); $k++) {
		if (($this->types_colonnes[$k] >= 3) && ($this->types_colonnes[$k] <= 5)) {
			$res="=;".(($this->types_colonnes[$k] == 3)?0:$this->Entrees_Sorties[$k]);
			$AAfficher=(($this->types_colonnes[$k] == 3)?0:$this->Entrees_Sorties[$k])."=";
			$tab=$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$k]))];
			$flag=false;
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$reactionsUtilisees[$j];
				$res.=";".$tab[$indi];
				if ($tab[$indi]*1 != 0) {
					$flag=true;
					$AAfficher.=(($tab[$indi]*1 > 0)?"+".$tab[$indi]:$tab[$indi])."v_".$this->getIdReact($indi,$indiceId)." ";
				}
			}
//			printf("%s -- %s\n",$AAfficher,$this->noms_colonnes[$k]);
			if ($flag) $ToutesContraintes["="][]=$res;
		}
	}
//printf("<pre>");

	// contraintes supplémentaires
	for ($i=0; $i<count($this->contraintes); $i++) {
		// Tester si c'est une contrainte...
		if ((trim($this->contraintes[$i]) != "") && (trim($this->contraintes[$i]) != "0")) {
			$cont=$this->Traitement($this->contraintes[$i],$reactionsId,$correspPivots);
			$signe=1;
			if ($cont["TYPE"] == "maximize") {$cont["TYPE"] = "m"; $signe=-1;}
			if ($cont["TYPE"] == "minimize") {$cont["TYPE"] = "m"; $signe=1;}
			if ($cont["CONST"] < 0) {$cont["CONST"] = -$cont["CONST"]; $signe=-$signe;}
			$res=$cont["TYPE"].";".$cont["CONST"];
			$AAfficher=$cont["CONST"].$cont["TYPE"];
//			print_r($cont);
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$this->getIdReact($reactionsUtilisees[$j],$indiceId);
				if (isset($cont["TERMES"][$indi-$rustine])) {
					$res.=";".($signe*($cont["TERMES"][$indi-$rustine]));
					$valeur=$signe*($cont["TERMES"][$indi-$rustine]);
					$AAfficher.=(($valeur > 0)?"+".$valeur:$valeur)."v_".$indi." ";

				} else $res.=";0";
			}
//			printf("%s\n",$AAfficher);
			$ToutesContraintes[$cont["TYPE"]][]=$res;		
		}
	}
	// objectif on suppose qu'il y en a un seul
	
	for ($k=0; $k<count($this->noms_colonnes); $k++) {
		if (($this->types_colonnes[$k] >= 6) && ($this->types_colonnes[$k] <= 7)) {
			$res="m;0"; $signe=(($this->types_colonnes[$k] == 6)?1:-1);
			$tab=$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$k]))];
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$reactionsUtilisees[$j];
				$res.=";".$tab[$indi]*$signe;
			}
//			printf("%s\n",$res);
			$ToutesContraintes["m"][]=$res;
		}
	}
	

// Reste les contraintes supplémentaires	
//		print_r($ToutesContraintes);
//      printf("</pre>");
		
	$D=new Matrice();
	$B=new Matrice();

	/*
	$fic=fopen("tmp/fichierphp.txt","r");
	$ToutesContraintes=array();
	$ToutesContraintes["="]=array();
	$ToutesContraintes["<"]=array();
	$ToutesContraintes[">"]=array();
	$ToutesContraintes["m"]=array();
	while ($ligne=trim(fgets($fic,4096))) {
		$ToutesContraintes[$ligne[0]][]=$ligne;
	}
	fclose($fic);
	*/
	$tabop=array("<","=","m");
	for($cle=0;$cle<count($tabop);$cle++) {
		$valeur=$tabop[$cle];
		for($i=0; $i<count($ToutesContraintes[$valeur]);$i++) {
			$ToutesContraintes[$valeur][$i]=split(";",$ToutesContraintes[$valeur][$i]);
		}
	}

	for($j=0; $j<count($ToutesContraintes["="]);$j++) {
		$obj=$ToutesContraintes["="][$j];
		for($i=2; $i<count($obj); $i++) {
			$D->Set($j,$i-2,$obj[$i]);
		}
		$B->Set($j,0,$obj[1]);
	}
//print_r($ToutesContraintes);
//	$D->PrettyPrint2($B,$nomfich,$reactionsUtilisees);
	$D->Gauss($B);
	$D->PrettyPrint2($B,$nomfich,$reactionsUtilisees);	
	
	
	
	
}

function ToMathSolve($nomfich="") {
	// quel est le numéro d'identifiant
	// Récupération des colonnes d'intérêt
	$indicenoms=1;
	$indiceId=-1;
	$indicesMetabolites=array();
	for ($i=0; $i<count($this->types_colonnes); $i++) {
		switch ($this->types_colonnes[$i]) {
			case 2: $indiceId=$i; break;
			case 1: $indicenoms=$i; break;
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
				$indicesMetabolites[]=$i; break;
		}
	}
	// affichage des variables
	$ToutesContraintes=array();
	$ToutesContraintes["<"]=array();
	$ToutesContraintes[">"]=array();
	$ToutesContraintes["="]=array();
	$ToutesContraintes["m"]=array();
	$ToutesContraintes["M"]=array();
	
	$reactionsUtilisees=array();
	$reactionsId=array();
	$rustine=1;
//	echo "<pre>";
	for ($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
		if ($this->equations_utilisees[$i+$rustine] == "on") {$reactionsUtilisees[]=$i;
			if ($this->Entrees[$i+$rustine] != "" && $this->Entrees[$i+$rustine] != "0") {
//					echo "  Egalité v_".$this->getIdReact($i,$indiceId)."=".$this->Entrees[$i+$rustine]." -- ".($i+$rustine)."\n";
			} else {
				if ($this->Sorties[$i+$rustine] != "" && $this->Sorties[$i+$rustine] != "0") {
//					echo "  Egalité v_".$this->getIdReact($i,$indiceId)."=".$this->Sorties[$i+$rustine]." -- ".($i+$rustine)."\n";
				} else {
//					echo "  Inégalité 0<=v_".$this->getIdReact($i,$indiceId)."<=100000000"." -- ".($i+$rustine)."\n";
				}
			}
		} // rustine décalage entre equations utilisées et matrice stoechiométrique !!!
		$reactionsId[$this->getIdReact($i,$indiceId)]=$i;
	}

/*
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
		$AAfficher="R_".$this->getIdReact($reaction-$rustine,$indiceId).":";
		$left="";
		$right="";
		for ($k=0; $k<count($this->noms_colonnes); $k++) {
			$valeur=$this->matrice_stoechiometrique[$reaction-$rustine][$k]*1;
			if (($this->types_colonnes[$k] >= 3) && ($this->types_colonnes[$k] <= 7) && ($valeur != 0)) {
			if ($valeur<0) {
				$left.=" +".abs($valeur)."*".$this->noms_colonnes[$k];
			} else {
				$right.=" +".abs($valeur)."*".$this->noms_colonnes[$k];
			}
			}
		}
		printf("%s %s => %s\n",$AAfficher,$left,$right);

	} 
*/
	$FixedValues=array();
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
			if ($this->Entrees[$reaction] != "" && $this->Entrees[$reaction] != "0") {
					$res="=;".$this->Entrees[$reaction];
					$FixedValues[$j]=$this->Entrees[$reaction];
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["=="][]=$res;
			} else {
				if ($this->Sorties[$reaction] != "" && $this->Sorties[$reaction] != "0") {
					$res="=;".$this->Sorties[$reaction];
					$FixedValues[$j]=$this->Sortie[$reaction];
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["=="][]=$res;
				} else {
					$res=">;0";
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes[">"][]=$res;
					$res="<;1000000000000";
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["<"][]=$res;
				}
			}
		} 
	

	// Contraintes supplémentaires
	
	// Premier travail, on exprime tous les noms de colonnes comme des combinaisons des variables (ici on ne distingue pas le type de la colonne, ce serait évidemment à faire normalement).
	$correspPivots=array();
	for ($j=0; $j<count($this->noms_colonnes); $j++) {
		$res=array();
		for ($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$res[]=$this->matrice_stoechiometrique[$i][$j];
		}
		$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$j]))]=$res; // mise en minuscule et suppression des espaces	
	} // avec ça, on doit pouvoir écrire des contraintes du type ATP=0...

//print_r($correspPivots["vlc"]);

	// Contraintes sur les pivots (type = 3)
	
//	print_r($correspPivots);
	
	for ($k=0; $k<count($this->noms_colonnes); $k++) {
		if (($this->types_colonnes[$k] >= 3) && ($this->types_colonnes[$k] <= 5)) {
			$res="=;".(($this->types_colonnes[$k] == 3)?0:$this->Entrees_Sorties[$k]);
			$AAfficher=(($this->types_colonnes[$k] == 3)?0:$this->Entrees_Sorties[$k])."=";
			$tab=$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$k]))];
			$flag=false;
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$reactionsUtilisees[$j];
				$res.=";".$tab[$indi];
				if ($tab[$indi]*1 != 0) {
					$flag=true;
					$AAfficher.=(($tab[$indi]*1 > 0)?"+".$tab[$indi]:$tab[$indi])."v_".$this->getIdReact($indi,$indiceId)." ";
				}
			}
//			printf("%s -- %s\n",$AAfficher,$this->noms_colonnes[$k]);
			if ($flag) $ToutesContraintes["="][]=$res;
		}
	}
//printf("<pre>");

	// contraintes supplémentaires
	for ($i=0; $i<count($this->contraintes); $i++) {
		// Tester si c'est une contrainte...
		if ((trim($this->contraintes[$i]) != "") && (trim($this->contraintes[$i]) != "0")) {
			$cont=$this->Traitement($this->contraintes[$i],$reactionsId,$correspPivots);
			$signe=1;
			if ($cont["TYPE"] == "maximize") {$cont["TYPE"] = "m"; $signe=-1;}
			if ($cont["TYPE"] == "minimize") {$cont["TYPE"] = "m"; $signe=1;}
			if ($cont["CONST"] < 0) {$cont["CONST"] = -$cont["CONST"]; $signe=-$signe;}
			$res=$cont["TYPE"].";".$cont["CONST"];
			$AAfficher=$cont["CONST"].$cont["TYPE"];
//			print_r($cont);
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$this->getIdReact($reactionsUtilisees[$j],$indiceId);
				if (isset($cont["TERMES"][$indi-$rustine])) {
					$res.=";".($signe*($cont["TERMES"][$indi-$rustine]));
					$valeur=$signe*($cont["TERMES"][$indi-$rustine]);
					$AAfficher.=(($valeur > 0)?"+".$valeur:$valeur)."v_".$indi." ";

				} else $res.=";0";
			}
//			printf("%s\n",$AAfficher);
			$ToutesContraintes[$cont["TYPE"]][]=$res;		
		}
	}
	// objectif on suppose qu'il y en a un seul
	
	for ($k=0; $k<count($this->noms_colonnes); $k++) {
		if (($this->types_colonnes[$k] >= 6) && ($this->types_colonnes[$k] <= 7)) {
			$res="m;0"; $signe=(($this->types_colonnes[$k] == 6)?1:-1);
			$tab=$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$k]))];
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$reactionsUtilisees[$j];
				$res.=";".$tab[$indi]*$signe;
			}
//			printf("%s\n",$res);
			$ToutesContraintes["m"][]=$res;
		}
	}
	/*
	$fic=fopen("tmp/fichierphp.txt","r");
	$ToutesContraintes=array();
	$ToutesContraintes["="]=array();
	$ToutesContraintes["<"]=array();
	$ToutesContraintes[">"]=array();
	$ToutesContraintes["m"]=array();
	while ($ligne=trim(fgets($fic,4096))) {
		$ToutesContraintes[$ligne[0]][]=$ligne;
	}
	fclose($fic);
	*/

// Reste les contraintes supplémentaires	
//		print_r($ToutesContraintes);
//      printf("</pre>");
	if ($nomfich == "") $fd=STDOUT; else $fd=fopen($nomfich,"w");
	
	fprintf($fd,"from FuncDesigner import *\nfrom openopt import LP\n");
	
	$tabop=array("<","=","m");
	for($cle=0;$cle<count($tabop);$cle++) {
		$valeur=$tabop[$cle];
		for($i=0; $i<count($ToutesContraintes[$valeur]);$i++) {
			$ToutesContraintes[$valeur][$i]=split(";",$ToutesContraintes[$valeur][$i]);
		}
	}
	$obj=$ToutesContraintes["m"][0]; // on ne garde que le premier objectif
	$signe="";
	
	$res="";
	$flag=false;
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		if ($flag) $res.=", ";
		$flag=true;
		$res.="R_".$reactionsUtilisees[$j];
	}
	$res.=" = oovars(".count($reactionsUtilisees).")\n";
	fprintf($fd,"%s",$res);
	
	
	$res="obj = "; $flag=false;
	for($i=2; $i<count($obj); $i++) {
		if ($flag) $signe="+ ";
		$flag=true;
		if ($obj[$i] != 0) $res.=$signe."(".$obj[$i].")*R_".$reactionsUtilisees[$i-2]; // (mt_rand()/mt_getrandmax()-0.5);
//		$res.=(mt_rand()/mt_getrandmax()-0.5);
	}
//	$res.="])\n";
	fprintf($fd,"%s\n\n",$res);

//	fprintf($fd,"A = []\n");
//	fprintf($fd,"b = []\n");

	$res="constraints = [";
	$flagbis=false;
	$signe="";
	for($j=0; $j<count($ToutesContraintes["="]);$j++) {
		if ($flagbis) $res.=", ";
		$flagbis=true;
		$obj=$ToutesContraintes["="][$j];
	    $flag=false;
		for($i=2; $i<count($obj); $i++) {
			if ($flag) $signe="+ ";
			$flag=true;
			if ($obj[$i] != 0) $res.=$signe."(".$obj[$i].")*R_".$reactionsUtilisees[$i-2]; // (mt_rand()/mt_getrandmax()-0.5);
		}
		if ($obj[1] != 0) $res.=" - (".$obj[1].")";
	}
	for($i=2; $i<count($obj); $i++) {
		if ($flag) $res.=",";
		$flag=true;
		if (isset($FixedValues[$i-2])) $res.="R_".$reactionsUtilisees[$i-2]."-".$FixedValues[$i-2].""; 
		else $res.="R_".$reactionsUtilisees[$i-2]."<10000000000" . ", R_".$reactionsUtilisees[$i-2].">0";
	}
	$res.="]\n";
	fprintf($fd,"%s",$res);


/*	$res="beq = (";
	$flagbis=false;
	for($j=0; $j<count($ToutesContraintes["="]);$j++) {
		if ($flagbis) $res.=", ";
		$flagbis=true;
		$res.=$ToutesContraintes["="][$j][1];
	}
	$res.=")\n";
*/

//	fprintf($fd,"%s",$res);



	$res="startPoint = {";
	$flag=false;
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		if ($flag) $res.=", ";
		$flag=true;
		if (isset($FixedValues[$i])) $res.="R_".$reactionsUtilisees[$j].": ".$FixedValues[$i]; else $res.="R_".$reactionsUtilisees[$j].": 0";
	}
	$res.=" }\n";
	fprintf($fd,"%s",$res);

	fputs($fd,"\n\np = LP(obj, startPoint, constraints = constraints)\nr = p.minimize('pclp')\nprint('objFunValue: %f' % r.ff)\nprint('x_opt: %s' % r.xf)\n");

/*
	$res="ub = ["; $flag=false;
	for($i=2; $i<count($obj); $i++) {
		if ($flag) $res.=", ";
		$flag=true;
		if (isset($FixedValues[$i-2])) $res.=$FixedValues[$i-2]; else $res.="inf";
//		$res.="inf";
	}
	$res.="]\n";
	fprintf($fd,"%s",$res);

	$res="Solution = ["; $flag=false;
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
		if ($flag) $res.=", ";
		$flag=true;
		if (isset($this->Solution[$reaction])) $res.=$this->Solution[$reaction]; else $res.="0";
	} 
	$res.="]\n";
	fprintf($fd,"%s",$res);
	

	fprintf($fd,"for j in range(10):\n");

	fprintf($fd,"\tfor i in range(size(f)):\n");
	fprintf($fd,"\t\tf[i]=random()-0.5\n");
	fprintf($fd,"\tp = LP(f, Aeq=Aeq, beq=beq, lb=lb, ub=ub)\n");
	fprintf($fd,"\tr = p.minimize('pclp')\n");
	fputs($fd,"\tprint('objFunValue: %f' % r.ff)\n");
	fputs($fd,"\tprint('x_opt: %s' % r.xf)\n");
//	fputs($fd,"\tprint('Score: %s' % dot(transpose(f),Solution))\n");
*/

	if ($nomfich != "") fclose($fd);
}



function ToOpenOpt($nomfich="") {
	// quel est le numéro d'identifiant
	// Récupération des colonnes d'intérêt
	$indicenoms=1;
	$indiceId=-1;
	$indicesMetabolites=array();
	for ($i=0; $i<count($this->types_colonnes); $i++) {
		switch ($this->types_colonnes[$i]) {
			case 2: $indiceId=$i; break;
			case 1: $indicenoms=$i; break;
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
				$indicesMetabolites[]=$i; break;
		}
	}
	// affichage des variables
	$ToutesContraintes=array();
	$ToutesContraintes["<"]=array();
	$ToutesContraintes[">"]=array();
	$ToutesContraintes["="]=array();
	$ToutesContraintes["m"]=array();
	$ToutesContraintes["M"]=array();
	
	$reactionsUtilisees=array();
	$reactionsId=array();
	$rustine=1;
//	echo "<pre>";
	for ($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
		if ($this->equations_utilisees[$i+$rustine] == "on") {$reactionsUtilisees[]=$i;
			if ($this->Entrees[$i+$rustine] != "" && $this->Entrees[$i+$rustine] != "0") {
//					echo "  Egalité v_".$this->getIdReact($i,$indiceId)."=".$this->Entrees[$i+$rustine]." -- ".($i+$rustine)."\n";
			} else {
				if ($this->Sorties[$i+$rustine] != "" && $this->Sorties[$i+$rustine] != "0") {
//					echo "  Egalité v_".$this->getIdReact($i,$indiceId)."=".$this->Sorties[$i+$rustine]." -- ".($i+$rustine)."\n";
				} else {
//					echo "  Inégalité 0<=v_".$this->getIdReact($i,$indiceId)."<=100000000"." -- ".($i+$rustine)."\n";
				}
			}
		} // rustine décalage entre equations utilisées et matrice stoechiométrique !!!
		$reactionsId[$this->getIdReact($i,$indiceId)]=$i;
	}

/*
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
		$AAfficher="R_".$this->getIdReact($reaction-$rustine,$indiceId).":";
		$left="";
		$right="";
		for ($k=0; $k<count($this->noms_colonnes); $k++) {
			$valeur=$this->matrice_stoechiometrique[$reaction-$rustine][$k]*1;
			if (($this->types_colonnes[$k] >= 3) && ($this->types_colonnes[$k] <= 7) && ($valeur != 0)) {
			if ($valeur<0) {
				$left.=" +".abs($valeur)."*".$this->noms_colonnes[$k];
			} else {
				$right.=" +".abs($valeur)."*".$this->noms_colonnes[$k];
			}
			}
		}
		printf("%s %s => %s\n",$AAfficher,$left,$right);

	} 
*/
	$FixedValues=array();
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
			if ($this->Entrees[$reaction] != "" && $this->Entrees[$reaction] != "0") {
					$res="=;".$this->Entrees[$reaction];
					$FixedValues[$j]=$this->Entrees[$reaction];
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["=="][]=$res;
			} else {
				if ($this->Sorties[$reaction] != "" && $this->Sorties[$reaction] != "0") {
					$res="=;".$this->Sorties[$reaction];
					$FixedValues[$j]=$this->Sortie[$reaction];
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["=="][]=$res;
				} else {
					$res=">;0";
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes[">"][]=$res;
					$res="<;1000000000000";
					for ($i=0; $i<count($reactionsUtilisees); $i++) {
						if ($i == $j) $res.="; 1"; else $res.="; 0";
					}
					$ToutesContraintes["<"][]=$res;
				}
			}
		} 
	

	// Contraintes supplémentaires
	
	// Premier travail, on exprime tous les noms de colonnes comme des combinaisons des variables (ici on ne distingue pas le type de la colonne, ce serait évidemment à faire normalement).
	$correspPivots=array();
	for ($j=0; $j<count($this->noms_colonnes); $j++) {
		$res=array();
		for ($i=0; $i<count($this->matrice_stoechiometrique); $i++) {
			$res[]=$this->matrice_stoechiometrique[$i][$j];
		}
		$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$j]))]=$res; // mise en minuscule et suppression des espaces	
	} // avec ça, on doit pouvoir écrire des contraintes du type ATP=0...

//print_r($correspPivots["glc"]);

	// Contraintes sur les pivots (type = 3)
	
//	print_r($correspPivots);
	
	for ($k=0; $k<count($this->noms_colonnes); $k++) {
		if (($this->types_colonnes[$k] >= 3) && ($this->types_colonnes[$k] <= 5)) {
			$res="=;".(($this->types_colonnes[$k] == 3)?0:$this->Entrees_Sorties[$k]);
			$AAfficher=(($this->types_colonnes[$k] == 3)?0:$this->Entrees_Sorties[$k])."=";
			$tab=$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$k]))];
			$flag=false;
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$reactionsUtilisees[$j];
				$res.=";".$tab[$indi];
				if ($tab[$indi]*1 != 0) {
					$flag=true;
					$AAfficher.=(($tab[$indi]*1 > 0)?"+".$tab[$indi]:$tab[$indi])."v_".$this->getIdReact($indi,$indiceId)." ";
				}
			}
//			printf("%s -- %s\n",$AAfficher,$this->noms_colonnes[$k]);
			if ($flag) $ToutesContraintes["="][]=$res;
		}
	}
//printf("<pre>");

	// contraintes supplémentaires
	for ($i=0; $i<count($this->contraintes); $i++) {
		// Tester si c'est une contrainte...
		if ((trim($this->contraintes[$i]) != "") && (trim($this->contraintes[$i]) != "0")) {
			$cont=$this->Traitement($this->contraintes[$i],$reactionsId,$correspPivots);
			$signe=1;
			if ($cont["TYPE"] == "maximize") {$cont["TYPE"] = "m"; $signe=-1;}
			if ($cont["TYPE"] == "minimize") {$cont["TYPE"] = "m"; $signe=1;}
			if ($cont["CONST"] < 0) {$cont["CONST"] = -$cont["CONST"]; $signe=-$signe;}
			$res=$cont["TYPE"].";".$cont["CONST"];
			$AAfficher=$cont["CONST"].$cont["TYPE"];
//			print_r($cont);
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$this->getIdReact($reactionsUtilisees[$j],$indiceId);
				if (isset($cont["TERMES"][$indi-$rustine])) {
					$res.=";".($signe*($cont["TERMES"][$indi-$rustine]));
					$valeur=$signe*($cont["TERMES"][$indi-$rustine]);
					$AAfficher.=(($valeur > 0)?"+".$valeur:$valeur)."v_".$indi." ";

				} else $res.=";0";
			}
//			printf("%s\n",$AAfficher);
			$ToutesContraintes[$cont["TYPE"]][]=$res;		
		}
	}
	// objectif on suppose qu'il y en a un seul
	
	for ($k=0; $k<count($this->noms_colonnes); $k++) {
		if (($this->types_colonnes[$k] >= 6) && ($this->types_colonnes[$k] <= 7)) {
			$res="m;0"; $signe=(($this->types_colonnes[$k] == 6)?1:-1);
			$tab=$correspPivots[str_replace(" ","",strtolower($this->noms_colonnes[$k]))];
			for ($j=0; $j<count($reactionsUtilisees); $j++) {
				$indi=$reactionsUtilisees[$j];
				$res.=";".$tab[$indi]*$signe;
			}
//			printf("%s\n",$res);
			$ToutesContraintes["m"][]=$res;
		}
	}
	
/*
	$fic=fopen("tmp/fichierphp.txt","r");
	$ToutesContraintes=array();
	$ToutesContraintes["="]=array();
	$ToutesContraintes["<"]=array();
	$ToutesContraintes[">"]=array();
	$ToutesContraintes["m"]=array();
	while ($ligne=trim(fgets($fic,4096))) {
		$ToutesContraintes[$ligne[0]][]=$ligne;
	}
	fclose($fic);
*/	

// Reste les contraintes supplémentaires	
//		print_r($ToutesContraintes);
//      printf("</pre>");
	if ($nomfich == "") $fd=STDOUT; else $fd=fopen($nomfich,"w");
	
	fprintf($fd,"from numpy import *\nfrom openopt import LP\nfrom random import *\n");
	
	$tabop=array("<","=","m");
	for($cle=0;$cle<count($tabop);$cle++) {
		$valeur=$tabop[$cle];
		for($i=0; $i<count($ToutesContraintes[$valeur]);$i++) {
			$ToutesContraintes[$valeur][$i]=split(";",$ToutesContraintes[$valeur][$i]);
		}
	}
	$obj=$ToutesContraintes["m"][0]; // on ne garde que le premier objectif
	$res="f = array(["; $flag=false;
	for($i=2; $i<count($obj); $i++) {
		if ($flag) $res.=",";
		$flag=true;
		$res.=$obj[$i]; // (mt_rand()/mt_getrandmax()-0.5);
//		$res.=(mt_rand()/mt_getrandmax()-0.5);
	}
	$res.="])\n";
	fprintf($fd,"%s",$res);

	fprintf($fd,"A = []\n");
	fprintf($fd,"b = []\n");

	$res="Aeq=mat('";
	$flagbis=false;
	for($j=0; $j<count($ToutesContraintes["="]);$j++) {
		if ($flagbis) $res.="; ";
		$flagbis=true;
		$obj=$ToutesContraintes["="][$j];
	    $flag=false;
		for($i=2; $i<count($obj); $i++) {
			if ($flag) $res.=" ";
			$flag=true;
			$res.=$obj[$i];
		}
	}
	$res.="')\n";
	fprintf($fd,"%s",$res);

	$res="beq = (";
	$flagbis=false;
	for($j=0; $j<count($ToutesContraintes["="]);$j++) {
		if ($flagbis) $res.=", ";
		$flagbis=true;
		$res.=$ToutesContraintes["="][$j][1];
	}
	$res.=")\n";
	fprintf($fd,"%s",$res);

	$res="lb = ["; $flag=false;
	for($i=2; $i<count($obj); $i++) {
		if ($flag) $res.=", ";
		$flag=true;
		if (isset($FixedValues[$i-2])) $res.=$FixedValues[$i-2]; else $res.="0";
	}
	$res.="]\n";
	fprintf($fd,"%s",$res);

	$res="ub = ["; $flag=false;
	for($i=2; $i<count($obj); $i++) {
		if ($flag) $res.=", ";
		$flag=true;
		if (isset($FixedValues[$i-2])) $res.=$FixedValues[$i-2]; else $res.="inf";
//		$res.="inf";
	}
	$res.="]\n";
	fprintf($fd,"%s",$res);

	$res="Solution = ["; $flag=false;
	for ($j=0; $j<count($reactionsUtilisees); $j++) {
		$reaction=$reactionsUtilisees[$j]+$rustine;
		if ($flag) $res.=", ";
		$flag=true;
		if (isset($this->Solution[$reaction])) $res.=$this->Solution[$reaction]; else $res.="0";
	} 
	$res.="]\n";
	fprintf($fd,"%s",$res);
	

	fprintf($fd,"for j in range(10):\n");

	fprintf($fd,"\tfor i in range(size(f)):\n");
	fprintf($fd,"\t\tf[i]=random()-0.5\n");
	fprintf($fd,"\tp = LP(f, Aeq=Aeq, beq=beq, lb=lb, ub=ub)\n");
	fprintf($fd,"\tr = p.minimize('pclp')\n");
	fputs($fd,"\tprint('objFunValue: %f' % r.ff)\n");
	fputs($fd,"\tprint('x_opt: %s' % r.xf)\n");
//	fputs($fd,"\tprint('Score: %s' % dot(transpose(f),Solution))\n");

	if ($nomfich != "") fclose($fd);
}













function CreateGraphGraphML($filename=STDOUT) {
		$fd=fopen($filename,"w");
		
		fprintf($fd,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<graphml xmlns=\"http://graphml.graphdrawing.org/xmlns\"\n    xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n    xsi:schemaLocation=\"http://graphml.graphdrawing.org/xmlns\n     http://graphml.graphdrawing.org/xmlns/1.0/graphml.xsd\">\n  <graph id=\"G\" edgedefault=\"directed\">\n");                 

fprintf($fd,"<key id=\"d0\" for=\"node\" attr.name=\"color\" attr.type=\"string\"/>");
fprintf($fd,"<key id=\"d1\" for=\"node\" attr.name=\"Text\" attr.type=\"string\"/>\n<key for=\"node\" id=\"d6\" yfiles.type=\"nodegraphics\"/>");

		for($i=0; $i<count($this->types_colonnes); $i++) {
			switch ($this->types_colonnes[$i]) {
				case 3:
                               // case 4: //////////
				case 5:
			
                        	fprintf($fd,"<node id=\"MI%s\"> <data key=\"d0\">green</data><data key=\"d6\">  <y:ShapeNode><y:Fill color=\"green\" transparent=\"false\"/><y:NodeLabel alignment=\"center\" autoSizePolicy=\"content\" fontFamily=\"Dialog\" fontSize=\"12\" fontStyle=\"plain\" textColor=\"black\" visible=\"true\">%s</y:NodeLabel><y:Shape type=\"octagon\"/></y:ShapeNode> </data> </node>\n",$i,$this->noms_colonnes[$i]);
                              //  break;
                              //  case 4:
                              //  fprintf($fd, "\tMI%s [label=\"%s\", shape=\"ellipse\", style=\"filled\", fillcolor=\"red\"];\n",$i,$this->noms_colonnes[$i]);
                        
			}
		}

		for($i=1; $i<count($this->equations_utilisees); $i++) {
			//fprintf($fd,">>>%s , %d\n",$this->equations_utilisees[$i],$this->Solution[$i]);
			if (($this->equations_utilisees[$i] == "on") && ($this->Solution[$i] != 0)) {
		        	//$label="\"eq ".$i."\\ncoeff=".$this->Solution[$i]."\\n";
                                //$label="\"eq ".$i."\\n";
				for($k=0; $k<count($this->types_colonnes); $k++) {
					switch ($this->types_colonnes[$k]) {
                                                case 4:
						case 6:
						case 7:
					        case 8:
					        case 9:
					        case 10:
						$label.=$this->noms_colonnes[$k]."=".($this->matrice_stoechiometrique[$i-1][$k]*$this->Solution[$i])."\\n";
                                                break;
                                                case 3:
                                              //  case 4: //////////
						case 5:
						if ($this->matrice_stoechiometrique[$i-1][$k] > 0) {
						$label.=$this->noms_colonnes[$k]."=".($this->matrice_stoechiometrique[$i-1][$k]*$this->Solution[$i])."\\n";	
						} else if ($this->matrice_stoechiometrique[$i-1][$k] < 0) {
						$label.=$this->noms_colonnes[$k]."=".($this->matrice_stoechiometrique[$i-1][$k]*$this->Solution[$i])."\\n";	
						}
					}
				}
				$label.="\"";

				fprintf($fd,"<node id=\"R%s\"> <data key=\"d0\">blue</data><data key=\"d6\"><y:ShapeNode><y:Fill color=\"blue\" transparent=\"false\"/><y:NodeLabel alignment=\"center\" autoSizePolicy=\"content\" fontFamily=\"Dialog\" fontSize=\"12\" fontStyle=\"plain\" textColor=\"black\" visible=\"true\">%s</y:NodeLabel><y:Shape type=\"octagon\"/></y:ShapeNode> </data> </node>\n",$i,$label);// [label=%s, style=\"filled\", fillcolor=\"%s\"];\n",$i,
					//$label,
					//"#FFAAAA"); //:(($matrice[$Equations[$i]][2]=="output")?"#FFAAFF":"#FFFFFF"));
				$left="";
				$right="";
				$ligne=$this->matrice_stoechiometrique[$i];
				$nbext=0;
				for($k=0; $k<count($this->types_colonnes); $k++) {
					switch ($this->types_colonnes[$k]) {
						case 3:
                                              //  case 4: ///////////
						case 5:
						if ($this->matrice_stoechiometrique[$i-1][$k] > 0) {
							$nbext++;
							fprintf($fd,"<edge source=\"R%d\" target=\"MI%d\"/>\n",$i,$k);
						} else if ($this->matrice_stoechiometrique[$i-1][$k] < 0) {
							fprintf($fd,"<edge source=\"MI%d\" target=\"R%d\"/>\n",$k,$i);
						}
					}
				}

				if ($nbext == 0) fprintf($fd,"<edge source=\"R%d\" target=\"R%d\"/>\n",$i,$i);
			}
		}
		fprintf($fd,"</graph>\n</graphml>");

		fclose($fd);
	}

/*
Creator	"yFiles"
Version	"2.9"
graph
[
	hierarchic	1
	label	""
	directed	1
	node
	[
		id	0
		label	"R1
V=200"
		graphics
		[
			type	"octagon"
			fill	"#FFCC00"
			outline	"#000000"
		]
	]
	node
	[
		id	1
		label	"M1"
		graphics
		[
			type	"rectangle"
			fill	"#00FF00"
			outline	"#000000"
		]
	]
	node
	[
		id	2
		label	"M2"
		graphics
		[
			type	"rectangle"
			fill	"#0000FF"
			outline	"#000000"
		]
	]
	node
	[
		id	3
		label	"M3"
		graphics
		[
			type	"rectangle"
			fill	"#FFCC00"
			outline	"#000000"
		]
	]
	edge
	[
		source	1
		target	0
		label	"Truc"
	]
	edge
	[
		source	0
		target	2
	]
	edge
	[
		source	0
		target	3
	]
]

*/


function CreateGraphGML($filename=STDOUT) {
		$fd=fopen($filename,"w");
		
		fprintf($fd,"Creator	\"nutritionAnalyzer\"\nVersion	\"0.9alpha\"\ngraph\n[\n\thierarchic	1\n\tdirected	1\n");

		for($i=0; $i<count($this->types_colonnes); $i++) {
			switch ($this->types_colonnes[$i]) {
				case 3:
				case 5:
			
                        	fprintf($fd,"\tnode\n\t\t[\n\t\tid	%s\n\t\tlabel	\"%s\"\n\t\tgraphics\n\t\t\t[\n\t\t\ttype	\"rectangle\"\n\t\t\tfill	\"#FF5555\"\n\t\t\toutline	\"#000000\"\n\t\t\t]\n\t\t]\n",10000+$i,$this->noms_colonnes[$i]);
                        
			}
		}

		for($i=1; $i<count($this->equations_utilisees); $i++) {
			if (($this->equations_utilisees[$i] == "on") && ($this->Solution[$i] != 0)) {
				$label="";
				for($k=0; $k<count($this->types_colonnes); $k++) {
					switch ($this->types_colonnes[$k]) {
                                                case 4:
						case 6:
						case 7:
					        case 8:
					        case 9:
					        case 10:
						$label.=$this->noms_colonnes[$k]."=".($this->matrice_stoechiometrique[$i-1][$k]*$this->Solution[$i])."\n";
                                                break;
                                    case 3:
						case 5:
						if ($this->matrice_stoechiometrique[$i-1][$k] > 0) {
						$label.=$this->noms_colonnes[$k]."=".($this->matrice_stoechiometrique[$i-1][$k]*$this->Solution[$i])."\n";	
						} else if ($this->matrice_stoechiometrique[$i-1][$k] < 0) {
						$label.=$this->noms_colonnes[$k]."=".($this->matrice_stoechiometrique[$i-1][$k]*$this->Solution[$i])."\n";	
						}
					}
				}
				$label.="";

				fprintf($fd,"\tnode\n\t\t[\n\t\tid	%s\n\t\tlabel	\"%s\"\n\t\tgraphics\n\t\t\t[\n\t\t\ttype	\"octagon\"\n\t\t\tfill	\"#5555FF\"\n\t\t\toutline	\"#000000\"\n\t\t\t]\n\t\t]\n",$i,$label);
				$left="";
				$right="";
				$ligne=$this->matrice_stoechiometrique[$i];
				$nbext=0;
				for($k=0; $k<count($this->types_colonnes); $k++) {
					switch ($this->types_colonnes[$k]) {
						case 3:
                                              //  case 4: ///////////
						case 5:
						if ($this->matrice_stoechiometrique[$i-1][$k] > 0) {
							$nbext++;
							fprintf($fd,"\tedge\n\t\t[\n\t\tsource %d\n\t\ttarget %d\n\t]\n",$i,10000+$k);
						} else if ($this->matrice_stoechiometrique[$i-1][$k] < 0) {
							fprintf($fd,"\tedge\n\t\t[\n\t\tsource %d\n\t\ttarget %d\n\t]\n",10000+$k,$i);
						}
					}
				}

				if ($nbext == 0) fprintf($fd,"\tedge\n\t\t[\n\t\tsource %d\n\t\ttarget %d\n\t]\n",$i,$i);
			}
		}
		fprintf($fd,"]\n");

		fclose($fd);
	}

}





