<?php

function distance(&$T1,&$T2) {
	$res=0;
	if (count(T1) == count(T2)) {
		foreach($T1 as $cle=>$valeur) {
			if (isset($T2[$cle])) {
				if ($T2[$cle]<100000 && $valeur<10000) $res+=abs($T2[$cle]-$valeur);
			} else if ($valeur != "") $res+=1000000;
		}
	} else $res+=1000000;
	return $res;
}

function distanceE(&$T1,&$T2) {
	$res=0;
	for($i=0; $i<count($T1); $i++) $res+=($T1[$i]-$T2[$i])*($T1[$i]-$T2[$i]);
	return $res;
}


function ajouteUnique(&$T1,&$T2) {
	$i=0;
	while ($i<count($T1) && distance($T1[$i],$T2)>0.000001) {
		$i++;
	}
	if ($i == count($T1)) {
		$T1[]=$T2;
		return 0;
	} else {return 1;}
}



include("Modele.php");
include("simplex_solver.php");

$filename=$argv[1];
$number=$argv[2];
$nbtirages=$argv[3];

//printf("-- %s , %s \n",$filename,$number);

if ($number>0) {
$Modele=new Modele();

$Modele->read($filename);

$reactionsUtilisees=array();
$rustine=1;

	for ($i=0; $i<count($Modele->matrice_stoechiometrique); $i++) {
		if ($Modele->equations_utilisees[$i+$rustine] == "on") {$reactionsUtilisees[]=$i;
		}
	}

if (! file_exists("pbtosolve.tmp")) $Modele->ToLinearSystem("pbtosolve.tmp");

$Problem=new LinearProblem();

//$Problem->FromFile("sortiephp_1356535645.txt");
$Problem->FromFile("pbtosolve.tmp");


// $nbtirages=1;
$nbsommets=0;

$k=0;

for($nbsol=0; $nbsol<$nbtirages; $nbsol++) {
//fprintf(STDERR,"Sommet no".($nbsol+1)."\n");
// modification de l'objectif


$Problemetmp=$Problem;


for ($c=1; $c<=$Problemetmp->N; $c++) {
	$Problemetmp->setXY($Problemetmp->M,$c,20*(mt_rand()/mt_getrandmax()-0.5));
}

/*
$c=1+(floor($k/2)%($Problemetmp->N+2));
$signe=($k%2)*2-1;
$Problemetmp->setXY($Problemetmp->M,$c,$signe*mt_rand()/mt_getrandmax());
*/


$Basis=array();

$LPCODE=$Problemetmp->solve(false,	$Basis, 0);
// echo "Code=".$LPCODE."\n";
$Solution=array();
for($i=0; $i<count($Basis); $i++) {
  $Solution[$Basis[$i]]=$Problemetmp->getXY($i,0);
}


$Solution2=array();
for ($i = 0; $i < count($reactionsUtilisees); $i++) {
  // printf("R_%d = %f\n",$reactionsUtilisees[$i]+1,  $Solution[$i+1]);	
  if (isset($Solution[$i + 1])) {
    $Solution2[$reactionsUtilisees[$i] + 1] = $Solution[$i + 1];
  } else {
    $Solution2[$reactionsUtilisees[$i] + 1] = 0;
  }
}
//print_r($Solution);

if (true) { //(ajouteUnique($ToutesSolutions,$Solution2) == 0) {
	$nbsommets++;
	$fd=fopen("solutions_calculees_".$number."_".$nbsol.".txt","w");
	for($i=0; $i<count($reactionsUtilisees); $i++) {
  		fprintf($fd,"%s%f",($i>0)?";":"",(isset($Solution2[$reactionsUtilisees[$i]]))?$Solution2[$reactionsUtilisees[$i]]:0);
  	}
  	fclose($fd);
}
$k++;

//fprintf(STDERR,"NbSommets = %d\n",$nbsommets);
}

} else {

$ToutesSolutions=array();
$nbsol=0;

$dir=opendir(".");


$fileno=0;
while ($fichier=readdir($dir)) {
	if (substr($fichier,0,strlen("solutions_calculees")) == "solutions_calculees") {

		$fd=fopen($fichier,"r");
		while ($ligne=fgetcsv($fd,4096,";")) {$ToutesSolutions[$nbsol++]=$ligne;}
		fclose($fd);
	}
$fileno++;
if ($fileno%50 == 0) {
$ToutesSolReal=array();
$nbsolreal=0;

for($i=0; $i<count($ToutesSolutions); $i++) {
	$sol1=$ToutesSolutions[$i]; 
	$distancemin=1000;
	for($j=0; $j<$i; $j++) {
		$sol2=$ToutesSolutions[$j]; 
		$distancecourante=distanceE($sol1,$sol2);
		if ($distancecourante<$distancemin) $distancemin=$distancecourante;
		//fprintf(STDERR,";%f",$distancecourante);
	}
	if ($distancemin>0.5) {$ToutesSolReal[$nbsolreal++]=$sol1; }
}
unset($ToutesSolutions);
$ToutesSolutions=$ToutesSolReal;
$nbsol=count($ToutesSolReal);
}

}


$ToutesSolReal=array();
$nbsolreal=0;

for($i=0; $i<count($ToutesSolutions); $i++) {
	$sol1=$ToutesSolutions[$i]; 
	$distancemin=1000;
	for($j=0; $j<$i; $j++) {
		$sol2=$ToutesSolutions[$j]; 
		$distancecourante=distanceE($sol1,$sol2);
		if ($distancecourante<$distancemin) $distancemin=$distancecourante;
		//fprintf(STDERR,";%f",$distancecourante);
	}
	if ($distancemin>0.5) {$ToutesSolReal[$nbsolreal++]=$sol1; }
}

echo "Total de ".count($ToutesSolReal)."\n";

for($i=0; $i<count($ToutesSolReal); $i++) {
	printf("%s\n",implode(";",$ToutesSolReal[$i]));
}

}

?>
